#!/bin/sh

DIE=0

PROG=WoB

(aclocal --version) < /dev/null > /dev/null 2>&1 ||
{
    echo
    echo "You must have aclocal installed to compile $PROG."
    DIE=1
}


(autoconf --version) < /dev/null > /dev/null 2>&1 ||
{
    echo
    echo "You must have autoconf installed to compile $PROG."
    DIE=1
}

(autoheader --version) < /dev/null > /dev/null 2>&1 ||
{
    echo
    echo "You must have autoheaderf installed to compile $PROG."
    DIE=1
}


# configure.in reqs automake-1.6; try to find it
version=`automake --version 2>/dev/null | head -1 | awk '{print $NF}' | 
awk -F. '{print $1 * 10 + $2}'`
if test "0$version" -le 15; then
	echo "You must have automake version superior or equal to 1.6 "
	DIE=1
fi

if test "$DIE" -eq 1; then
    exit 1
fi


aclocal && autoconf && autoheader && automake -c -a

echo
echo "Now type './configure' with wished options and follow with"
echo " 'make' to compile $PROG."
echo
