
//----------------------------------------------------------------------------
inline Arc2::Arc2 ()
{
    // no initialization for efficiency
}
//----------------------------------------------------------------------------
inline Vector2& Arc2::End0 ()
{
    return m_kEnd0;
}
//----------------------------------------------------------------------------
inline const Vector2& Arc2::End0 () const
{
    return m_kEnd0;
}
//----------------------------------------------------------------------------
inline Vector2& Arc2::End1 ()
{
    return m_kEnd1;
}
//----------------------------------------------------------------------------
inline const Vector2& Arc2::End1 () const
{
    return m_kEnd1;
}
//----------------------------------------------------------------------------
inline bool Arc2::Contains (const Vector2& _Point) const
{
    // Assert: |P-C| = R where P is the input point, C is the circle center,
    // and R is the circle radius.  For P to be on the arc from A to B, it
    // must be on the side of the plane containing A with normal N = Perp(B-A)
    // where Perp(u,v) = (v,-u).

    Real fLhs = (_Point.x - m_kEnd0.x)*(m_kEnd1.y - m_kEnd0.y);
    Real fRhs = (_Point.y - m_kEnd0.y)*(m_kEnd1.x - m_kEnd0.x);
    return fLhs >= fRhs;
}
//----------------------------------------------------------------------------


