#ifndef GEOMCIRCLE2_H
#define GEOMCIRCLE2_H

#include "GeomPrimitivForm.h"
#include "MagicFMLibType.h"
#include "GeomVector2.h"
#include <string>
 using namespace std;


namespace Geom {


  class MAGICFM Circle2 : public PrimitivForm
{
public:
    Circle2 ();
	
	string type() {return "Circle";}
	
    Vector2& Center ();
    const Vector2& Center () const;

    Real& Radius ();
    const Real& Radius () const;
	
	// rotations & translations
	virtual void Translate(Real _tx, Real _ty)
	  {
		m_kCenter.Translate(_tx,_ty);
	  }
	virtual void Rotate(Real _cost, Real _sint, Real _centerx, Real _centery)
	  {
		m_kCenter.Rotate(_cost,_sint,_centerx,_centery);
	  }
	virtual void Rotate(Real _theta, Real _centerx, Real _centery)
	  {
		m_kCenter.Rotate(_theta,_centerx,_centery);
	  }
	
	
protected:
    Vector2 m_kCenter;
    Real m_fRadius;
};

#include "GeomCircle2.inl"

} // namespace Geom

#endif


