#ifndef GEOMFORM_H
#define GEOMFORM_H

#include<vector>
//#include <limits>
#include "GeomIntersection2D.pkg"

namespace Geom {

  class Form
	{
	public:
	  //Real centerx;  //coords of the center of the form 
	  //Real centery;
	  
	  //PrimitivForm surrounding_form;
	  
	  Real x_max;   // Horizontal Box over the fast to fast detection
	  Real y_max;   // of obvious cases with no collision
	  Real x_min; 
	  Real y_min;
	  vector<PrimitivForm *> forms; 
	  unsigned color;
	  

	  void Calc_boundingbox()
		{
		  x_min=RAND_MAX;//numeric_limits<Real>::max(); // infinite bouding box
		  y_min=RAND_MAX;//numeric_limits<Real>::max();
		  x_max=-RAND_MAX;//numeric_limits<Real>::max();
		  y_max=-RAND_MAX;//numeric_limits<Real>::max();
		  
		  //calcul of best values for bounding box
		  // MAL CODE AURAIT DU ETRE UNE FONCTION VIRTUELLE
		  for (vector<PrimitivForm *>::iterator it1=forms.begin();it1 != forms.end();it1++) 
			{
			  string typ=(*it1)->type();
			  if (typ=="Segment")
				{
#ifdef _WIN32
				  Segment2 * seg=(static_cast<Segment2 *>(*it1));
#else
				  Segment2 * seg=(dynamic_cast<Segment2 *>(*it1));
#endif

#ifdef _WIN32
				  x_min=min(x_min,(seg->Origin()).x);
				  x_min=min(x_min,(seg->Origin()).x+(seg->Direction()).x);
				  x_max=max(x_max,(seg->Origin()).x);
				  x_max=max(x_max,(seg->Origin()).x+(seg->Direction()).x);
				  y_min=min(y_min,(seg->Origin()).y);
				  y_min=min(y_min,(seg->Origin()).y+(seg->Direction()).y);
				  y_max=max(y_max,(seg->Origin()).y);
				  y_max=max(y_max,(seg->Origin()).y+(seg->Direction()).y);
#else
				  x_min=min<Real>(x_min,(seg->Origin()).x);
				  x_min=min<Real>(x_min,(seg->Origin()).x+(seg->Direction()).x);
				  x_max=max<Real>(x_max,(seg->Origin()).x);
				  x_max=max<Real>(x_max,(seg->Origin()).x+(seg->Direction()).x);
				  y_min=min<Real>(y_min,(seg->Origin()).y);
				  y_min=min<Real>(y_min,(seg->Origin()).y+(seg->Direction()).y);
				  y_max=max<Real>(y_max,(seg->Origin()).y);
				  y_max=max<Real>(y_max,(seg->Origin()).y+(seg->Direction()).y);
#endif
				  
				  
				  /*
				  if (x_min > ((seg->Origin()).x ))
					{x_min=((seg->Origin()).x );}
				  if (x_min > ((seg->Origin()).x + (seg->Direction()).x  ))
					{x_min=((seg->Origin()).x+ (seg->Direction()).x );}
				  if (x_max < ((seg->Origin()).x ))
					{x_max=((seg->Origin()).x );}
				  if (x_max < ((seg->Origin()).x + (seg->Direction()).x  ))
					{x_max=((seg->Origin()).x+ (seg->Direction()).x );}
				  if (y_min > ((seg->Origin()).y ))
					{y_min=((seg->Origin()).y );}
				  if (y_min > ((seg->Origin()).y + (seg->Direction()).y  ))
					{y_min=((seg->Origin()).y+ (seg->Direction()).y );}
				  if (y_max < ((seg->Origin()).y ))
					{y_max=((seg->Origin()).y );}
				  if (y_max < ((seg->Origin()).y + (seg->Direction()).y  ))
					{y_max=((seg->Origin()).y+ (seg->Direction()).y );}
				  */
				}
			  
			  if (typ=="Line")
				{
#ifdef _WIN32
				  Line2 * lin=(static_cast<Line2 *>(*it1));
#else
				  Line2 * lin=(dynamic_cast<Line2 *>(*it1));				  
#endif
				  
#ifdef _WIN32
				  x_min=min(lin->Origin().x,x_min);
				  y_min=min(lin->Origin().y,y_min);
				  x_max=max(lin->Origin().x,x_max);
				  y_max=max(lin->Origin().y,y_max);
#else
				  x_min=min<Real>(lin->Origin().x,x_min);
				  y_min=min<Real>(lin->Origin().y,y_min);
				  x_max=max<Real>(lin->Origin().x,x_max);
				  y_max=max<Real>(lin->Origin().y,y_max);
#endif
				  
				  
				  if (((lin->Direction()).x)!=0)
					{x_min=-RAND_MAX;//numeric_limits<Real>::max();
					x_max=RAND_MAX;//numeric_limits<Real>::max();
					}
				  if (((lin->Direction()).y)!=0)
					{y_min=-RAND_MAX;//numeric_limits<Real>::max();
					y_max=RAND_MAX;//numeric_limits<Real>::max();
					}
				}

			  if (typ=="Ray")
				{
#ifdef _WIN32
				  Ray2 * ray=(static_cast<Ray2 *>(*it1));
#else
				  Ray2 * ray=(dynamic_cast<Ray2 *>(*it1));
#endif

				  
#ifdef _WIN32
				  x_min=min(ray->Origin().x,x_min);
				  y_min=min(ray->Origin().y,y_min);
				  x_max=max(ray->Origin().x,x_max);
				  y_max=max(ray->Origin().y,y_max);
#else
				  x_min=min<Real>(ray->Origin().x,x_min);
				  y_min=min<Real>(ray->Origin().y,y_min);
				  x_max=max<Real>(ray->Origin().x,x_max);
				  y_max=max<Real>(ray->Origin().y,y_max);

#endif
				  				  
				  if (((ray->Direction()).x)>0)
					{x_max=RAND_MAX;//numeric_limits<Real>::max();
					}
				  if (((ray->Direction()).x)<0)
					{x_min= -RAND_MAX;//numeric_limits<Real>::max();
					}
				  if (((ray->Direction()).y)>0)
					{y_max=RAND_MAX;//numeric_limits<Real>::max();
					}
				  if (((ray->Direction()).y)<0)
					{y_min= -RAND_MAX;//numeric_limits<Real>::max();
					}
				}
			  

			  if (typ=="Circle"||typ=="Arc")
				{
#ifdef _WIN32
				  Circle2 * cir=(static_cast<Circle2 *>(*it1));
#else
				  Circle2 * cir=(dynamic_cast<Circle2 *>(*it1));
#endif

				  if (x_min > ((cir->Center()).x-(cir->Radius())))
					{x_min=((cir->Center()).x-(cir->Radius())); }
				  if (x_max < ((cir->Center()).x+(cir->Radius())))
					{x_max=((cir->Center()).x+(cir->Radius())); }
				  if (y_min > ((cir->Center()).y-(cir->Radius())))
					{y_min=((cir->Center()).y-(cir->Radius())); }
				  if (y_max < ((cir->Center()).y+(cir->Radius())))
					{y_max=((cir->Center()).y+(cir->Radius())); }
				}
			  
			    if (typ=="Box")
				{
#ifdef _WIN32
				  Box2 * box=(static_cast<Box2 *>(*it1));
#else
				  Box2 * box=(dynamic_cast<Box2 *>(*it1));
#endif
				  
				  Vector2 Vertex[4];
				  box->ComputeVertices(Vertex);

				  
				  for (int ii=0;ii<4;ii++)
					{
					  if (x_min > (Vertex[ii].x))
					  {x_min=Vertex[ii].x; }
					  if (x_max < (Vertex[ii].x))
					  {x_max=Vertex[ii].x; }
					  if (y_min > (Vertex[ii].y))
					  {y_min=Vertex[ii].y; }
					  if (y_max < (Vertex[ii].y))
					  {y_max=Vertex[ii].y; }
					}
				  
					  
				  
					}
			}
		}
	  
	  
	  Form(vector<PrimitivForm *> _forms,unsigned _col=255)  //Constructor
		{
		  forms=_forms;
		  color=_col;
		  Calc_boundingbox();
		  		 
		}

	  void Translate (Real _tx,Real _ty)
		{
		  x_min+=_tx;
		  x_max+=_tx;
		  y_min+=_ty;
		  y_max+=_ty;
		
		  for (vector<PrimitivForm *>::iterator it1=forms.begin();it1 != forms.end();it1++) 
			{
			  (*it1)->Translate(_tx,_ty);
			}
		}

	  void Rotate (Real _theta,Real _centerx, Real _centery)
		{
		  
		  if (forms.size()==1)
			{
			  if (forms[0]->type()=="Circle")
				{
#ifdef _WIN32
				  Circle2 * cir=(static_cast<Circle2 *>(forms[0]));
#else
				  Circle2 * cir=(dynamic_cast<Circle2 *>(forms[0]));
#endif
				  if (((cir->Center()).x)==_centerx)
					{
					  if (((cir->Center()).y)==_centery)
						{
						  return;
						}
					}
				}
			}
		  		  
		  Real sint=sin(_theta);
		  Real cost=cos(_theta);
		  
		  
		  for (vector<PrimitivForm *>::iterator it1=forms.begin();it1 != forms.end();it1++) 
			{
			  (*it1)->Rotate(cost,sint,_centerx,_centery);
			  
			}
		  Calc_boundingbox();
		  
		}
	  
	  
	  
	};

  
} // namespace Geom

#endif
