
#ifndef GEOMINTR2DLINCIR_H
#define GEOMINTR2DLINCIR_H

#include "GeomArc2.h"
#include "GeomCircle2.h"
#include "GeomLine2.h"
#include "GeomRay2.h"
#include "GeomSegment2.h"

namespace Geom {

// The return value is 'true' if and only if the objects intersect.  The
// returned quantity is 0, 1, or 2 and is the number of valid points in
// akPoint[2] (the intersection points).

MAGICFM bool FindIntersection (const Line2& _Line, const Circle2& _Circle,
    int& riQuantity, Vector2 akPoint[2]);

MAGICFM bool FindIntersection (const Line2& _Line, const Arc2& _Arc,
    int& riQuantity, Vector2 akPoint[2]);

MAGICFM bool FindIntersection (const Ray2& _Ray, const Circle2& _Circle,
    int& riQuantity, Vector2 akPoint[2]);

MAGICFM bool FindIntersection (const Ray2& _Ray, const Arc2& _Arc,
    int& riQuantity, Vector2 akPoint[2]);

MAGICFM bool FindIntersection (const Segment2& _Segment,
    const Circle2& _Circle, int& riQuantity, Vector2 akPoint[2]);

MAGICFM bool FindIntersection (const Segment2& _Segment, const Arc2& _Arc,
    int& riQuantity, Vector2 akPoint[2]);

} // namespace Geom

#endif


