#ifndef GEOMRAY2_H
#define GEOMRAY2_H

#include "GeomPrimitivForm.h"
#include "MagicFMLibType.h"
#include "GeomVector2.h"
#include <string>
using namespace std;

namespace Geom {


  class MAGICFM Ray2 : public PrimitivForm
{
public:
    // Ray is R(t) = P+t*D for t >= 0.  D is not necessarily unit length.
  Ray2 ();
  string type() {return "Ray";}
	
    Vector2& Origin ();
    const Vector2& Origin () const;

    Vector2& Direction ();
    const Vector2& Direction () const;
	
	// rotations & translations
	virtual void Translate(Real _tx, Real _ty)
	  {
		m_kOrigin.Translate(_tx,_ty);
	  }
	virtual void Rotate(Real _cost, Real _sint, Real _centerx, Real _centery)
	  {
		m_kOrigin.Rotate(_cost,_sint,_centerx,_centery);
		m_kDirection.Rotate(_cost,_sint,_centerx,_centery);
		
	  }
	virtual void Rotate(Real _theta, Real _centerx, Real _centery)
	  {
		m_kOrigin.Rotate(_theta,_centerx,_centery);
		m_kDirection.Rotate(_theta,_centerx,_centery);
	  }
	
protected:
    Vector2 m_kOrigin;  // P
    Vector2 m_kDirection;  // D
};

#include "GeomRay2.inl"

} // namespace Geom

#endif


