
#ifndef GEOMINTR2DELPELP_H
#define GEOMINTR2DELPELP_H

#include "GeomVector2.h"

namespace Geom {


// The quadratic equation representing the ellipse is
//   Q(x,y) = a*x^2 + b*x*y + c*y^2 + d*x + e*y + f = 0
// where b*b < 4*a*c is required for this to represent an ellipse.
class MAGICFM QuadPoly2
{
public:
    Real m_fA, m_fB, m_fC, m_fD, m_fE, m_fF;

    bool IsEllipse ();
};

// On return, riQuantity is the number of intersections (in {0,1,2,3,4}) and
// akP[0],...,akP[riQuantity-1] are the points of intersection.
MAGICFM void FindIntersection (const QuadPoly2& _E0, const QuadPoly2& _E1,
    int& riQuantity, Vector2 akP[4]);

// Return value is 'true' if and only if there is an intersection.  If there
// is no intersection, the ellipses are either separated by a line or one is
// properly contained in the other.
MAGICFM bool TestIntersection (const QuadPoly2& _E0, const QuadPoly2& _E1);

} // namespace Geom

#endif


