#ifndef SCALE_GL
#define SCALE_GL 200
#endif


#ifndef GLHEADER
#define GLHEADER

#include "global.h"

#ifndef DONT_USE_GL

#ifdef _WIN32
 #include <windows.h>
 #include <GL/gl.h>
 #include <GL/glu.h>
 #include <GL/glut.h>
#elif defined(linux) || defined(__CYGWIN__)
 #include <GL/gl.h>
 #include <GL/glu.h>
 #include <GL/glut.h>
#elif defined(_DARWIN)
 #include <OpenGL/gl.h>
 #include <OpenGL/glu.h>
 #include <GLUT/glut.h>
#elif 
 #include <GL/gl.h>
 #include <GL/glu.h>
 #include <GL/glut.h>
#endif
 #include "../mui/mui.h"


#else
#include "fake_GL.h"
#endif

#include "math.h"
#include <string>


void drawCylinder(float r, float h,int dx, int dy,bool plein,double amax=2.0*M_PI);

void drawConea(float r1,float r2, float h,int dx);

void DrawCircle2D(float xcenter,float ycenter,float radius,float c1,float c2,float c3);

void DrawRectangle2D(float _x, float _y, float _length, float _width, float _r, float _v, float _b);

void DrawRectangle3D(float _x, float _y, float _height, float _length, float _width, float _r, float _v, float _b, float _a);

void DrawString (float _x, float _y,const char *s,float _z=0.0);

void DrawBigString (float _x, float _y,const char *s);

#endif
