#ifndef CAMERA_1D_H
#define CAMERA_1D_H


#include "global.h"
#include "../GEOMsources/GeomFormCollisionDetection.h"

#include "light.h"

#include <math.h>
#include <vector>

using namespace std;
using namespace Geom;


class Camera_1D
{
 private:

 Real Range; 
 unsigned* picture;
 bool calc_done;
 int number_of_pixels;
 
  
 public:
  
  Vector2 Center;
  Real direction;
  
  Real Perception_Angle;

  Camera_1D(Real _position_x0,Real _position_y0,Real _direction,
			Real _Perception_Angle=KHEPERA_CAM_1D_ANGLE_X,
		   int _number_of_pixels=KHEPERA_CAM_1D_X)
  {
	Center.x=_position_x0;
	Center.y=_position_y0;
	Range=1000;
	
	direction=_direction;

	Perception_Angle=_Perception_Angle;
	number_of_pixels=_number_of_pixels;
	picture=new(unsigned[_number_of_pixels*3]);
	
  }

  unsigned* camera1D();
  
  void calcule_picture(vector<Form *> _vf);
  
  void Translate(Real _tx, Real _ty);
  void Rotate(Real _theta, Real _centerx, Real _centery);
  void Reset();
  
  
  ~Camera_1D()
	{
	  delete picture;
	}
  
};




#endif
