#include "fake_GL.h"

#ifdef DONT_USE_GL
GLUTidleCB __glutIdleFunc = NULL;


void  glClearIndex( GLfloat c ){};

void  glClearColor( GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha ){};

void  glClear( GLbitfield mask ){};

void  glIndexMask( GLuint mask ){};

void  glColorMask( GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha ){};

void  glAlphaFunc( GLenum func, GLclampf ref ){};

void  glBlendFunc( GLenum sfactor, GLenum dfactor ){};

void  glLogicOp( GLenum opcode ){};

void  glCullFace( GLenum mode ){};

void  glFrontFace( GLenum mode ){};

void  glPointSize( GLfloat size ){};

void  glLineWidth( GLfloat width ){};

void  glLineStipple( GLint factor, GLushort pattern ){};

void  glPolygonMode( GLenum face, GLenum mode ){};

void  glPolygonOffset( GLfloat factor, GLfloat units ){};

void  glPolygonStipple( const GLubyte *mask ){};

void  glGetPolygonStipple( GLubyte *mask ){};

void  glEdgeFlag( GLboolean flag ){};

void  glEdgeFlagv( const GLboolean *flag ){};

void  glScissor( GLint x, GLint y, GLsizei width, GLsizei height){};

void  glClipPlane( GLenum plane, const GLdouble *equation ){};

void  glGetClipPlane( GLenum plane, GLdouble *equation ){};

void  glDrawBuffer( GLenum mode ){};

void  glReadBuffer( GLenum mode ){};

void  glEnable( GLenum cap ){};

void  glDisable( GLenum cap ){};

GLboolean  glIsEnabled( GLenum cap ){return true;};


void  glEnableClientState( GLenum cap ){};  /* 1.1 */

void  glDisableClientState( GLenum cap ){};  /* 1.1 */


void  glGetBooleanv( GLenum pname, GLboolean *params ){};

void  glGetDoublev( GLenum pname, GLdouble *params ){};

void  glGetFloatv( GLenum pname, GLfloat *params ){};

void  glGetIntegerv( GLenum pname, GLint *params ){};


void  glPushAttrib( GLbitfield mask ){};

void  glPopAttrib( void ){};


void  glPushClientAttrib( GLbitfield mask ){};  /* 1.1 */

void  glPopClientAttrib( void ){};  /* 1.1 */


GLint  glRenderMode( GLenum mode ){return 0;};

GLenum  glGetError( void ){return 0;};

const GLubyte*  glGetString( GLenum name ){return 0;};

void  glFinish( void ){};

void  glFlush( void ){};

void  glHint( GLenum target, GLenum mode ){};



/*
 * Depth Buffer
 */

void  glClearDepth( GLclampd depth ){};

void  glDepthFunc( GLenum func ){};

void  glDepthMask( GLboolean flag ){};

void  glDepthRange( GLclampd near_val, GLclampd far_val ){};


/*
 * Accumulation Buffer
 */

void  glClearAccum( GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha ){};

void  glAccum( GLenum op, GLfloat value ){};



/*
 * Transformation
 */

void  glMatrixMode( GLenum mode ){};

void  glOrtho( GLdouble left, GLdouble right,
                                 GLdouble bottom, GLdouble top,
                                 GLdouble near_val, GLdouble far_val ){};

void  glFrustum( GLdouble left, GLdouble right,
                                   GLdouble bottom, GLdouble top,
                                   GLdouble near_val, GLdouble far_val ){};

void  glViewport( GLint x, GLint y,
                                    GLsizei width, GLsizei height ){};

void  glPushMatrix( void ){};

void  glPopMatrix( void ){};

void  glLoadIdentity( void ){};

void  glLoadMatrixd( const GLdouble *m ){};
void  glLoadMatrixf( const GLfloat *m ){};

void  glMultMatrixd( const GLdouble *m ){};
void  glMultMatrixf( const GLfloat *m ){};

void  glRotated( GLdouble angle,
                                   GLdouble x, GLdouble y, GLdouble z ){};
void  glRotatef( GLfloat angle,
                                   GLfloat x, GLfloat y, GLfloat z ){};

void  glScaled( GLdouble x, GLdouble y, GLdouble z ){};
void  glScalef( GLfloat x, GLfloat y, GLfloat z ){};

void  glTranslated( GLdouble x, GLdouble y, GLdouble z ){};
void  glTranslatef( GLfloat x, GLfloat y, GLfloat z ){};



/*
 * Display Lists
 */

GLboolean  glIsList( GLuint list ){return true;};

void  glDeleteLists( GLuint list, GLsizei range ){};

GLuint  glGenLists( GLsizei range ){return 0;};

void  glNewList( GLuint list, GLenum mode ){};

void  glEndList( void ){};

void  glCallList( GLuint list ){};

void  glCallLists( GLsizei n, GLenum type,
                                     const GLvoid *lists ){};

void  glListBase( GLuint base ){};



/*
 * Drawing Functions
 */

void  glBegin( GLenum mode ){};

void  glEnd( void ){};


void  glVertex2d( GLdouble x, GLdouble y ){};
void  glVertex2f( GLfloat x, GLfloat y ){};
void  glVertex2i( GLint x, GLint y ){};
void  glVertex2s( GLshort x, GLshort y ){};

void  glVertex3d( GLdouble x, GLdouble y, GLdouble z ){};
void  glVertex3f( GLfloat x, GLfloat y, GLfloat z ){};
void  glVertex3i( GLint x, GLint y, GLint z ){};
void  glVertex3s( GLshort x, GLshort y, GLshort z ){};

void  glVertex4d( GLdouble x, GLdouble y, GLdouble z, GLdouble w ){};
void  glVertex4f( GLfloat x, GLfloat y, GLfloat z, GLfloat w ){};
void  glVertex4i( GLint x, GLint y, GLint z, GLint w ){};
void  glVertex4s( GLshort x, GLshort y, GLshort z, GLshort w ){};

void  glVertex2dv( const GLdouble *v ){};
void  glVertex2fv( const GLfloat *v ){};
void  glVertex2iv( const GLint *v ){};
void  glVertex2sv( const GLshort *v ){};

void  glVertex3dv( const GLdouble *v ){};
void  glVertex3fv( const GLfloat *v ){};
void  glVertex3iv( const GLint *v ){};
void  glVertex3sv( const GLshort *v ){};

void  glVertex4dv( const GLdouble *v ){};
void  glVertex4fv( const GLfloat *v ){};
void  glVertex4iv( const GLint *v ){};
void  glVertex4sv( const GLshort *v ){};


void  glNormal3b( GLbyte nx, GLbyte ny, GLbyte nz ){};
void  glNormal3d( GLdouble nx, GLdouble ny, GLdouble nz ){};
void  glNormal3f( GLfloat nx, GLfloat ny, GLfloat nz ){};
void  glNormal3i( GLint nx, GLint ny, GLint nz ){};
void  glNormal3s( GLshort nx, GLshort ny, GLshort nz ){};

void  glNormal3bv( const GLbyte *v ){};
void  glNormal3dv( const GLdouble *v ){};
void  glNormal3fv( const GLfloat *v ){};
void  glNormal3iv( const GLint *v ){};
void  glNormal3sv( const GLshort *v ){};


void  glIndexd( GLdouble c ){};
void  glIndexf( GLfloat c ){};
void  glIndexi( GLint c ){};
void  glIndexs( GLshort c ){};
void  glIndexub( GLubyte c ){};  /* 1.1 */

void  glIndexdv( const GLdouble *c ){};
void  glIndexfv( const GLfloat *c ){};
void  glIndexiv( const GLint *c ){};
void  glIndexsv( const GLshort *c ){};
void  glIndexubv( const GLubyte *c ){};  /* 1.1 */

void  glColor3b( GLbyte red, GLbyte green, GLbyte blue ){};
void  glColor3d( GLdouble red, GLdouble green, GLdouble blue ){};
void  glColor3f( GLfloat red, GLfloat green, GLfloat blue ){};
void  glColor3i( GLint red, GLint green, GLint blue ){};
void  glColor3s( GLshort red, GLshort green, GLshort blue ){};
void  glColor3ub( GLubyte red, GLubyte green, GLubyte blue ){};
void  glColor3ui( GLuint red, GLuint green, GLuint blue ){};
void  glColor3us( GLushort red, GLushort green, GLushort blue ){};

void  glColor4b( GLbyte red, GLbyte green,
                                   GLbyte blue, GLbyte alpha ){};
void  glColor4d( GLdouble red, GLdouble green,
                                   GLdouble blue, GLdouble alpha ){};
void  glColor4f( GLfloat red, GLfloat green,
                                   GLfloat blue, GLfloat alpha ){};
void  glColor4i( GLint red, GLint green,
                                   GLint blue, GLint alpha ){};
void  glColor4s( GLshort red, GLshort green,
                                   GLshort blue, GLshort alpha ){};
void  glColor4ub( GLubyte red, GLubyte green,
                                    GLubyte blue, GLubyte alpha ){};
void  glColor4ui( GLuint red, GLuint green,
                                    GLuint blue, GLuint alpha ){};
void  glColor4us( GLushort red, GLushort green,
                                    GLushort blue, GLushort alpha ){};


void  glColor3bv( const GLbyte *v ){};
void  glColor3dv( const GLdouble *v ){};
void  glColor3fv( const GLfloat *v ){};
void  glColor3iv( const GLint *v ){};
void  glColor3sv( const GLshort *v ){};
void  glColor3ubv( const GLubyte *v ){};
void  glColor3uiv( const GLuint *v ){};
void  glColor3usv( const GLushort *v ){};

void  glColor4bv( const GLbyte *v ){};
void  glColor4dv( const GLdouble *v ){};
void  glColor4fv( const GLfloat *v ){};
void  glColor4iv( const GLint *v ){};
void  glColor4sv( const GLshort *v ){};
void  glColor4ubv( const GLubyte *v ){};
void  glColor4uiv( const GLuint *v ){};
void  glColor4usv( const GLushort *v ){};


void  glTexCoord1d( GLdouble s ){};
void  glTexCoord1f( GLfloat s ){};
void  glTexCoord1i( GLint s ){};
void  glTexCoord1s( GLshort s ){};

void  glTexCoord2d( GLdouble s, GLdouble t ){};
void  glTexCoord2f( GLfloat s, GLfloat t ){};
void  glTexCoord2i( GLint s, GLint t ){};
void  glTexCoord2s( GLshort s, GLshort t ){};

void  glTexCoord3d( GLdouble s, GLdouble t, GLdouble r ){};
void  glTexCoord3f( GLfloat s, GLfloat t, GLfloat r ){};
void  glTexCoord3i( GLint s, GLint t, GLint r ){};
void  glTexCoord3s( GLshort s, GLshort t, GLshort r ){};

void  glTexCoord4d( GLdouble s, GLdouble t, GLdouble r, GLdouble q ){};
void  glTexCoord4f( GLfloat s, GLfloat t, GLfloat r, GLfloat q ){};
void  glTexCoord4i( GLint s, GLint t, GLint r, GLint q ){};
void  glTexCoord4s( GLshort s, GLshort t, GLshort r, GLshort q ){};

void  glTexCoord1dv( const GLdouble *v ){};
void  glTexCoord1fv( const GLfloat *v ){};
void  glTexCoord1iv( const GLint *v ){};
void  glTexCoord1sv( const GLshort *v ){};

void  glTexCoord2dv( const GLdouble *v ){};
void  glTexCoord2fv( const GLfloat *v ){};
void  glTexCoord2iv( const GLint *v ){};
void  glTexCoord2sv( const GLshort *v ){};

void  glTexCoord3dv( const GLdouble *v ){};
void  glTexCoord3fv( const GLfloat *v ){};
void  glTexCoord3iv( const GLint *v ){};
void  glTexCoord3sv( const GLshort *v ){};

void  glTexCoord4dv( const GLdouble *v ){};
void  glTexCoord4fv( const GLfloat *v ){};
void  glTexCoord4iv( const GLint *v ){};
void  glTexCoord4sv( const GLshort *v ){};


void  glRasterPos2d( GLdouble x, GLdouble y ){};
void  glRasterPos2f( GLfloat x, GLfloat y ){};
void  glRasterPos2i( GLint x, GLint y ){};
void  glRasterPos2s( GLshort x, GLshort y ){};

void  glRasterPos3d( GLdouble x, GLdouble y, GLdouble z ){};
void  glRasterPos3f( GLfloat x, GLfloat y, GLfloat z ){};
void  glRasterPos3i( GLint x, GLint y, GLint z ){};
void  glRasterPos3s( GLshort x, GLshort y, GLshort z ){};

void  glRasterPos4d( GLdouble x, GLdouble y, GLdouble z, GLdouble w ){};
void  glRasterPos4f( GLfloat x, GLfloat y, GLfloat z, GLfloat w ){};
void  glRasterPos4i( GLint x, GLint y, GLint z, GLint w ){};
void  glRasterPos4s( GLshort x, GLshort y, GLshort z, GLshort w ){};

void  glRasterPos2dv( const GLdouble *v ){};
void  glRasterPos2fv( const GLfloat *v ){};
void  glRasterPos2iv( const GLint *v ){};
void  glRasterPos2sv( const GLshort *v ){};

void  glRasterPos3dv( const GLdouble *v ){};
void  glRasterPos3fv( const GLfloat *v ){};
void  glRasterPos3iv( const GLint *v ){};
void  glRasterPos3sv( const GLshort *v ){};

void  glRasterPos4dv( const GLdouble *v ){};
void  glRasterPos4fv( const GLfloat *v ){};
void  glRasterPos4iv( const GLint *v ){};
void  glRasterPos4sv( const GLshort *v ){};


void  glRectd( GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2 ){};
void  glRectf( GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2 ){};
void  glRecti( GLint x1, GLint y1, GLint x2, GLint y2 ){};
void  glRects( GLshort x1, GLshort y1, GLshort x2, GLshort y2 ){};


void  glRectdv( const GLdouble *v1, const GLdouble *v2 ){};
void  glRectfv( const GLfloat *v1, const GLfloat *v2 ){};
void  glRectiv( const GLint *v1, const GLint *v2 ){};
void  glRectsv( const GLshort *v1, const GLshort *v2 ){};



/*
 * Vertex Arrays  (1.1)
 */

void  glVertexPointer( GLint size, GLenum type,
                                       GLsizei stride, const GLvoid *ptr ){};

void  glNormalPointer( GLenum type, GLsizei stride,
                                       const GLvoid *ptr ){};

void  glColorPointer( GLint size, GLenum type,
                                      GLsizei stride, const GLvoid *ptr ){};

void  glIndexPointer( GLenum type, GLsizei stride,
                                      const GLvoid *ptr ){};

void  glTexCoordPointer( GLint size, GLenum type,
                                         GLsizei stride, const GLvoid *ptr ){};

void  glEdgeFlagPointer( GLsizei stride, const GLvoid *ptr ){};

void  glGetPointerv( GLenum pname, GLvoid **params ){};

void  glArrayElement( GLint i ){};

void  glDrawArrays( GLenum mode, GLint first, GLsizei count ){};

void  glDrawElements( GLenum mode, GLsizei count,
                                      GLenum type, const GLvoid *indices ){};

void  glInterleavedArrays( GLenum format, GLsizei stride,
                                           const GLvoid *pointer ){};


/*
 * Lighting
 */

void  glShadeModel( GLenum mode ){};

void  glLightf( GLenum light, GLenum pname, GLfloat param ){};
void  glLighti( GLenum light, GLenum pname, GLint param ){};
void  glLightfv( GLenum light, GLenum pname,
                                 const GLfloat *params ){};
void  glLightiv( GLenum light, GLenum pname,
                                 const GLint *params ){};

void  glGetLightfv( GLenum light, GLenum pname,
                                    GLfloat *params ){};
void  glGetLightiv( GLenum light, GLenum pname,
                                    GLint *params ){};

void  glLightModelf( GLenum pname, GLfloat param ){};
void  glLightModeli( GLenum pname, GLint param ){};
void  glLightModelfv( GLenum pname, const GLfloat *params ){};
void  glLightModeliv( GLenum pname, const GLint *params ){};

void  glMaterialf( GLenum face, GLenum pname, GLfloat param ){};
void  glMateriali( GLenum face, GLenum pname, GLint param ){};
void  glMaterialfv( GLenum face, GLenum pname, const GLfloat *params ){};
void  glMaterialiv( GLenum face, GLenum pname, const GLint *params ){};

void  glGetMaterialfv( GLenum face, GLenum pname, GLfloat *params ){};
void  glGetMaterialiv( GLenum face, GLenum pname, GLint *params ){};

void  glColorMaterial( GLenum face, GLenum mode ){};




/*
 * Raster functions
 */

void  glPixelZoom( GLfloat xfactor, GLfloat yfactor ){};

void  glPixelStoref( GLenum pname, GLfloat param ){};
void  glPixelStorei( GLenum pname, GLint param ){};

void  glPixelTransferf( GLenum pname, GLfloat param ){};
void  glPixelTransferi( GLenum pname, GLint param ){};

void  glPixelMapfv( GLenum map, GLint mapsize,
                                    const GLfloat *values ){};
void  glPixelMapuiv( GLenum map, GLint mapsize,
                                     const GLuint *values ){};
void  glPixelMapusv( GLenum map, GLint mapsize,
                                     const GLushort *values ){};

void  glGetPixelMapfv( GLenum map, GLfloat *values ){};
void  glGetPixelMapuiv( GLenum map, GLuint *values ){};
void  glGetPixelMapusv( GLenum map, GLushort *values ){};

void  glBitmap( GLsizei width, GLsizei height,
                                GLfloat xorig, GLfloat yorig,
                                GLfloat xmove, GLfloat ymove,
                                const GLubyte *bitmap ){};

void  glReadPixels( GLint x, GLint y,
                                    GLsizei width, GLsizei height,
                                    GLenum format, GLenum type,
                                    GLvoid *pixels ){};

void  glDrawPixels( GLsizei width, GLsizei height,
                                    GLenum format, GLenum type,
                                    const GLvoid *pixels ){};

void  glCopyPixels( GLint x, GLint y,
                                    GLsizei width, GLsizei height,
                                    GLenum type ){};



/*
 * Stenciling
 */

void  glStencilFunc( GLenum func, GLint ref, GLuint mask ){};

void  glStencilMask( GLuint mask ){};

void  glStencilOp( GLenum fail, GLenum zfail, GLenum zpass ){};

void  glClearStencil( GLint s ){};



/*
 * Texture mapping
 */

void  glTexGend( GLenum coord, GLenum pname, GLdouble param ){};
void  glTexGenf( GLenum coord, GLenum pname, GLfloat param ){};
void  glTexGeni( GLenum coord, GLenum pname, GLint param ){};

void  glTexGendv( GLenum coord, GLenum pname, const GLdouble *params ){};
void  glTexGenfv( GLenum coord, GLenum pname, const GLfloat *params ){};
void  glTexGeniv( GLenum coord, GLenum pname, const GLint *params ){};

void  glGetTexGendv( GLenum coord, GLenum pname, GLdouble *params ){};
void  glGetTexGenfv( GLenum coord, GLenum pname, GLfloat *params ){};
void  glGetTexGeniv( GLenum coord, GLenum pname, GLint *params ){};


void  glTexEnvf( GLenum target, GLenum pname, GLfloat param ){};
void  glTexEnvi( GLenum target, GLenum pname, GLint param ){};

void  glTexEnvfv( GLenum target, GLenum pname, const GLfloat *params ){};
void  glTexEnviv( GLenum target, GLenum pname, const GLint *params ){};

void  glGetTexEnvfv( GLenum target, GLenum pname, GLfloat *params ){};
void  glGetTexEnviv( GLenum target, GLenum pname, GLint *params ){};


void  glTexParameterf( GLenum target, GLenum pname, GLfloat param ){};
void  glTexParameteri( GLenum target, GLenum pname, GLint param ){};

void  glTexParameterfv( GLenum target, GLenum pname,
                                          const GLfloat *params ){};
void  glTexParameteriv( GLenum target, GLenum pname,
                                          const GLint *params ){};

void  glGetTexParameterfv( GLenum target,
                                           GLenum pname, GLfloat *params){};
void  glGetTexParameteriv( GLenum target,
                                           GLenum pname, GLint *params ){};

void  glGetTexLevelParameterfv( GLenum target, GLint level,
                                                GLenum pname, GLfloat *params ){};
void  glGetTexLevelParameteriv( GLenum target, GLint level,
                                                GLenum pname, GLint *params ){};


void  glTexImage1D( GLenum target, GLint level,
                                    GLint internalFormat,
                                    GLsizei width, GLint border,
                                    GLenum format, GLenum type,
                                    const GLvoid *pixels ){};

void  glTexImage2D( GLenum target, GLint level,
                                    GLint internalFormat,
                                    GLsizei width, GLsizei height,
                                    GLint border, GLenum format, GLenum type,
                                    const GLvoid *pixels ){};

void  glGetTexImage( GLenum target, GLint level,
                                     GLenum format, GLenum type,
                                     GLvoid *pixels ){};



/* 1.1 functions */

void  glGenTextures( GLsizei n, GLuint *textures ){};

void  glDeleteTextures( GLsizei n, const GLuint *textures){};

void  glBindTexture( GLenum target, GLuint texture ){};

void  glPrioritizeTextures( GLsizei n,
                                            const GLuint *textures,
                                            const GLclampf *priorities ){};

GLboolean  glAreTexturesResident( GLsizei n,
                                                  const GLuint *textures,
                                                  GLboolean *residences ){return true;};

GLboolean  glIsTexture( GLuint texture ){return true;};


void  glTexSubImage1D( GLenum target, GLint level,
                                       GLint xoffset,
                                       GLsizei width, GLenum format,
                                       GLenum type, const GLvoid *pixels ){};


void  glTexSubImage2D( GLenum target, GLint level,
                                       GLint xoffset, GLint yoffset,
                                       GLsizei width, GLsizei height,
                                       GLenum format, GLenum type,
                                       const GLvoid *pixels ){};


void  glCopyTexImage1D( GLenum target, GLint level,
                                        GLenum internalformat,
                                        GLint x, GLint y,
                                        GLsizei width, GLint border ){};


void  glCopyTexImage2D( GLenum target, GLint level,
                                        GLenum internalformat,
                                        GLint x, GLint y,
                                        GLsizei width, GLsizei height,
                                        GLint border ){};


void  glCopyTexSubImage1D( GLenum target, GLint level,
                                           GLint xoffset, GLint x, GLint y,
                                           GLsizei width ){};


void  glCopyTexSubImage2D( GLenum target, GLint level,
                                           GLint xoffset, GLint yoffset,
                                           GLint x, GLint y,
                                           GLsizei width, GLsizei height ){};




/*
 * Evaluators
 */

void  glMap1d( GLenum target, GLdouble u1, GLdouble u2,
                               GLint stride,
                               GLint order, const GLdouble *points ){};
void  glMap1f( GLenum target, GLfloat u1, GLfloat u2,
                               GLint stride,
                               GLint order, const GLfloat *points ){};

void  glMap2d( GLenum target,
		     GLdouble u1, GLdouble u2, GLint ustride, GLint uorder,
		     GLdouble v1, GLdouble v2, GLint vstride, GLint vorder,
		     const GLdouble *points ){};
void  glMap2f( GLenum target,
		     GLfloat u1, GLfloat u2, GLint ustride, GLint uorder,
		     GLfloat v1, GLfloat v2, GLint vstride, GLint vorder,
		     const GLfloat *points ){};

void  glGetMapdv( GLenum target, GLenum query, GLdouble *v ){};
void  glGetMapfv( GLenum target, GLenum query, GLfloat *v ){};
void  glGetMapiv( GLenum target, GLenum query, GLint *v ){};

void  glEvalCoord1d( GLdouble u ){};
void  glEvalCoord1f( GLfloat u ){};

void  glEvalCoord1dv( const GLdouble *u ){};
void  glEvalCoord1fv( const GLfloat *u ){};

void  glEvalCoord2d( GLdouble u, GLdouble v ){};
void  glEvalCoord2f( GLfloat u, GLfloat v ){};

void  glEvalCoord2dv( const GLdouble *u ){};
void  glEvalCoord2fv( const GLfloat *u ){};

void  glMapGrid1d( GLint un, GLdouble u1, GLdouble u2 ){};
void  glMapGrid1f( GLint un, GLfloat u1, GLfloat u2 ){};

void  glMapGrid2d( GLint un, GLdouble u1, GLdouble u2,
                                   GLint vn, GLdouble v1, GLdouble v2 ){};
void  glMapGrid2f( GLint un, GLfloat u1, GLfloat u2,
                                   GLint vn, GLfloat v1, GLfloat v2 ){};

void  glEvalPoint1( GLint i ){};

void  glEvalPoint2( GLint i, GLint j ){};

void  glEvalMesh1( GLenum mode, GLint i1, GLint i2 ){};

void  glEvalMesh2( GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2 ){};



/*
 * Fog
 */

void  glFogf( GLenum pname, GLfloat param ){};

void  glFogi( GLenum pname, GLint param ){};

void  glFogfv( GLenum pname, const GLfloat *params ){};

void  glFogiv( GLenum pname, const GLint *params ){};



/*
 * Selection and Feedback
 */

void  glFeedbackBuffer( GLsizei size, GLenum type, GLfloat *buffer ){};

void  glPassThrough( GLfloat token ){};

void  glSelectBuffer( GLsizei size, GLuint *buffer ){};

void  glInitNames( void ){};

void  glLoadName( GLuint name ){};

void  glPushName( GLuint name ){};

void  glPopName( void ){};



/* 1.2 functions */
void  glDrawRangeElements( GLenum mode, GLuint start,
	GLuint end, GLsizei count, GLenum type, const GLvoid *indices ){};

void  glTexImage3D( GLenum target, GLint level,
                                      GLenum internalFormat,
                                      GLsizei width, GLsizei height,
                                      GLsizei depth, GLint border,
                                      GLenum format, GLenum type,
                                      const GLvoid *pixels ){};

void  glTexSubImage3D( GLenum target, GLint level,
                                         GLint xoffset, GLint yoffset,
                                         GLint zoffset, GLsizei width,
                                         GLsizei height, GLsizei depth,
                                         GLenum format,
                                         GLenum type, const GLvoid *pixels){};

void  glCopyTexSubImage3D( GLenum target, GLint level,
                                             GLint xoffset, GLint yoffset,
                                             GLint zoffset, GLint x,
                                             GLint y, GLsizei width,
                                             GLsizei height ){};


/* 1.2 imaging extension functions */

void  glColorTable( GLenum target, GLenum internalformat,
                                    GLsizei width, GLenum format,
                                    GLenum type, const GLvoid *table ){};

void  glColorSubTable( GLenum target,
                                       GLsizei start, GLsizei count,
                                       GLenum format, GLenum type,
                                       const GLvoid *data ){};

void  glColorTableParameteriv(GLenum target, GLenum pname,
                                              const GLint *params){};

void  glColorTableParameterfv(GLenum target, GLenum pname,
                                              const GLfloat *params){};

void  glCopyColorSubTable( GLenum target, GLsizei start,
                                           GLint x, GLint y, GLsizei width ){};

void  glCopyColorTable( GLenum target, GLenum internalformat,
                                        GLint x, GLint y, GLsizei width ){};

void  glGetColorTable( GLenum target, GLenum format,
                                       GLenum type, GLvoid *table ){};

void  glGetColorTableParameterfv( GLenum target, GLenum pname,
                                                  GLfloat *params ){};

void  glGetColorTableParameteriv( GLenum target, GLenum pname,
                                                  GLint *params ){};

void  glBlendEquation( GLenum mode ){};

void  glBlendColor( GLclampf red, GLclampf green,
                                    GLclampf blue, GLclampf alpha ){};

void  glHistogram( GLenum target, GLsizei width,
				   GLenum internalformat, GLboolean sink ){};

void  glResetHistogram( GLenum target ){};

void  glGetHistogram( GLenum target, GLboolean reset,
				      GLenum format, GLenum type,
				      GLvoid *values ){};

void  glGetHistogramParameterfv( GLenum target, GLenum pname,
						 GLfloat *params ){};

void  glGetHistogramParameteriv( GLenum target, GLenum pname,
						 GLint *params ){};

void  glMinmax( GLenum target, GLenum internalformat,
				GLboolean sink ){};

void  glResetMinmax( GLenum target ){};

void  glGetMinmax( GLenum target, GLboolean reset,
                                   GLenum format, GLenum types,
                                   GLvoid *values ){};

void  glGetMinmaxParameterfv( GLenum target, GLenum pname,
					      GLfloat *params ){};

void  glGetMinmaxParameteriv( GLenum target, GLenum pname,
					      GLint *params ){};

void  glConvolutionFilter1D( GLenum target,
	GLenum internalformat, GLsizei width, GLenum format, GLenum type,
	const GLvoid *image ){};

void  glConvolutionFilter2D( GLenum target,
	GLenum internalformat, GLsizei width, GLsizei height, GLenum format,
	GLenum type, const GLvoid *image ){};

void  glConvolutionParameterf( GLenum target, GLenum pname,
	GLfloat params ){};

void  glConvolutionParameterfv( GLenum target, GLenum pname,
	const GLfloat *params ){};

void  glConvolutionParameteri( GLenum target, GLenum pname,
	GLint params ){};

void  glConvolutionParameteriv( GLenum target, GLenum pname,
	const GLint *params ){};

void  glCopyConvolutionFilter1D( GLenum target,
	GLenum internalformat, GLint x, GLint y, GLsizei width ){};

void  glCopyConvolutionFilter2D( GLenum target,
	GLenum internalformat, GLint x, GLint y, GLsizei width,
	GLsizei height){};

void  glGetConvolutionFilter( GLenum target, GLenum format,
	GLenum type, GLvoid *image ){};

void  glGetConvolutionParameterfv( GLenum target, GLenum pname,
	GLfloat *params ){};

void  glGetConvolutionParameteriv( GLenum target, GLenum pname,
	GLint *params ){};

void  glSeparableFilter2D( GLenum target,
	GLenum internalformat, GLsizei width, GLsizei height, GLenum format,
	GLenum type, const GLvoid *row, const GLvoid *column ){};

void  glGetSeparableFilter( GLenum target, GLenum format,
	GLenum type, GLvoid *row, GLvoid *column, GLvoid *span ){};



/* 1.3 functions */

void  glActiveTexture( GLenum texture ){};

void  glClientActiveTexture( GLenum texture ){};

void  glCompressedTexImage1D( GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data ){};

void  glCompressedTexImage2D( GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data ){};

void  glCompressedTexImage3D( GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data ){};

void  glCompressedTexSubImage1D( GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data ){};

void  glCompressedTexSubImage2D( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data ){};

void  glCompressedTexSubImage3D( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data ){};

void  glGetCompressedTexImage( GLenum target, GLint lod, GLvoid *img ){};

void  glMultiTexCoord1d( GLenum target, GLdouble s ){};

void  glMultiTexCoord1dv( GLenum target, const GLdouble *v ){};

void  glMultiTexCoord1f( GLenum target, GLfloat s ){};

void  glMultiTexCoord1fv( GLenum target, const GLfloat *v ){};

void  glMultiTexCoord1i( GLenum target, GLint s ){};

void  glMultiTexCoord1iv( GLenum target, const GLint *v ){};

void  glMultiTexCoord1s( GLenum target, GLshort s ){};

void  glMultiTexCoord1sv( GLenum target, const GLshort *v ){};

void  glMultiTexCoord2d( GLenum target, GLdouble s, GLdouble t ){};

void  glMultiTexCoord2dv( GLenum target, const GLdouble *v ){};

void  glMultiTexCoord2f( GLenum target, GLfloat s, GLfloat t ){};

void  glMultiTexCoord2fv( GLenum target, const GLfloat *v ){};

void  glMultiTexCoord2i( GLenum target, GLint s, GLint t ){};

void  glMultiTexCoord2iv( GLenum target, const GLint *v ){};

void  glMultiTexCoord2s( GLenum target, GLshort s, GLshort t ){};

void  glMultiTexCoord2sv( GLenum target, const GLshort *v ){};

void  glMultiTexCoord3d( GLenum target, GLdouble s, GLdouble t, GLdouble r ){};

void  glMultiTexCoord3dv( GLenum target, const GLdouble *v ){};

void  glMultiTexCoord3f( GLenum target, GLfloat s, GLfloat t, GLfloat r ){};

void  glMultiTexCoord3fv( GLenum target, const GLfloat *v ){};

void  glMultiTexCoord3i( GLenum target, GLint s, GLint t, GLint r ){};

void  glMultiTexCoord3iv( GLenum target, const GLint *v ){};

void  glMultiTexCoord3s( GLenum target, GLshort s, GLshort t, GLshort r ){};

void  glMultiTexCoord3sv( GLenum target, const GLshort *v ){};

void  glMultiTexCoord4d( GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q ){};

void  glMultiTexCoord4dv( GLenum target, const GLdouble *v ){};

void  glMultiTexCoord4f( GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q ){};

void  glMultiTexCoord4fv( GLenum target, const GLfloat *v ){};

void  glMultiTexCoord4i( GLenum target, GLint s, GLint t, GLint r, GLint q ){};

void  glMultiTexCoord4iv( GLenum target, const GLint *v ){};

void  glMultiTexCoord4s( GLenum target, GLshort s, GLshort t, GLshort r, GLshort q ){};

void  glMultiTexCoord4sv( GLenum target, const GLshort *v ){};


void  glLoadTransposeMatrixd( const GLdouble m[16] ){};

void  glLoadTransposeMatrixf( const GLfloat m[16] ){};

void  glMultTransposeMatrixd( const GLdouble m[16] ){};

void  glMultTransposeMatrixf( const GLfloat m[16] ){};

void  glSampleCoverage( GLclampf value, GLboolean invert ){};


void  glActiveTextureARB(GLenum texture){};
void  glClientActiveTextureARB(GLenum texture){};
void  glMultiTexCoord1dARB(GLenum target, GLdouble s){};
void  glMultiTexCoord1dvARB(GLenum target, const GLdouble *v){};
void  glMultiTexCoord1fARB(GLenum target, GLfloat s){};
void  glMultiTexCoord1fvARB(GLenum target, const GLfloat *v){};
void  glMultiTexCoord1iARB(GLenum target, GLint s){};
void  glMultiTexCoord1ivARB(GLenum target, const GLint *v){};
void  glMultiTexCoord1sARB(GLenum target, GLshort s){};
void  glMultiTexCoord1svARB(GLenum target, const GLshort *v){};
void  glMultiTexCoord2dARB(GLenum target, GLdouble s, GLdouble t){};
void  glMultiTexCoord2dvARB(GLenum target, const GLdouble *v){};
void  glMultiTexCoord2fARB(GLenum target, GLfloat s, GLfloat t){};
void  glMultiTexCoord2fvARB(GLenum target, const GLfloat *v){};
void  glMultiTexCoord2iARB(GLenum target, GLint s, GLint t){};
void  glMultiTexCoord2ivARB(GLenum target, const GLint *v){};
void  glMultiTexCoord2sARB(GLenum target, GLshort s, GLshort t){};
void  glMultiTexCoord2svARB(GLenum target, const GLshort *v){};
void  glMultiTexCoord3dARB(GLenum target, GLdouble s, GLdouble t, GLdouble r){};
void  glMultiTexCoord3dvARB(GLenum target, const GLdouble *v){};
void  glMultiTexCoord3fARB(GLenum target, GLfloat s, GLfloat t, GLfloat r){};
void  glMultiTexCoord3fvARB(GLenum target, const GLfloat *v){};
void  glMultiTexCoord3iARB(GLenum target, GLint s, GLint t, GLint r){};
void  glMultiTexCoord3ivARB(GLenum target, const GLint *v){};
void  glMultiTexCoord3sARB(GLenum target, GLshort s, GLshort t, GLshort r){};
void  glMultiTexCoord3svARB(GLenum target, const GLshort *v){};
void  glMultiTexCoord4dARB(GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q){};
void  glMultiTexCoord4dvARB(GLenum target, const GLdouble *v){};
void  glMultiTexCoord4fARB(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q){};
void  glMultiTexCoord4fvARB(GLenum target, const GLfloat *v){};
void  glMultiTexCoord4iARB(GLenum target, GLint s, GLint t, GLint r, GLint q){};
void  glMultiTexCoord4ivARB(GLenum target, const GLint *v){};
void  glMultiTexCoord4sARB(GLenum target, GLshort s, GLshort t, GLshort r, GLshort q){};
void  glMultiTexCoord4svARB(GLenum target, const GLshort *v){};

void  glTexImage3DEXT( GLenum target, GLint level, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels ){};

void  glTexSubImage3DEXT( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels){};

void  glCopyTexSubImage3DEXT( GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height ){};

void  glVertexPointerEXT( GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *ptr ){};

void  glNormalPointerEXT( GLenum type, GLsizei stride, GLsizei count, const GLvoid *ptr ){};

void  glColorPointerEXT( GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *ptr ){};

void  glIndexPointerEXT( GLenum type, GLsizei stride, GLsizei count, const GLvoid *ptr ){};

void  glTexCoordPointerEXT( GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *ptr ){};

void  glEdgeFlagPointerEXT( GLsizei stride, GLsizei count, const GLboolean *ptr ){};

void  glGetPointervEXT( GLenum pname, GLvoid **params ){};

void  glArrayElementEXT( GLint i ){};

void  glDrawArraysEXT( GLenum mode, GLint first, GLsizei count ){};

void  glPointParameterfEXT( GLenum pname, GLfloat param ){};
void  glPointParameterfvEXT( GLenum pname, const GLfloat *params ){};
void  glPointParameterfSGIS(GLenum pname, GLfloat param){};
void  glPointParameterfvSGIS(GLenum pname, const GLfloat *params){};



void  glColorTableEXT( GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *table ){};

void  glColorSubTableEXT( GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const GLvoid *data ){};

void  glGetColorTableEXT( GLenum target, GLenum format, GLenum type, GLvoid *table ){};

void  glGetColorTableParameterfvEXT( GLenum target, GLenum pname, GLfloat *params ){};

void  glGetColorTableParameterivEXT( GLenum target, GLenum pname, GLint *params ){};

void  glLockArraysEXT( GLint first, GLsizei count ){};
void  glUnlockArraysEXT( void ){};

 void gluBeginCurve (GLUnurbs* nurb){};
 void gluBeginPolygon (GLUtesselator* tess){};
 void gluBeginSurface (GLUnurbs* nurb){};
 void gluBeginTrim (GLUnurbs* nurb){};
 GLint gluBuild1DMipmapLevels (GLenum target, GLint internalFormat, GLsizei width, GLenum format, GLenum type, GLint level, GLint base, GLint max, const void *data){return 0;};
 GLint gluBuild1DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLenum format, GLenum type, const void *data){return 0;};
 GLint gluBuild2DMipmapLevels (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLenum format, GLenum type, GLint level, GLint base, GLint max, const void *data){return 0;};
 GLint gluBuild2DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLenum format, GLenum type, const void *data){return 0;};
 GLint gluBuild3DMipmapLevels (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, GLint level, GLint base, GLint max, const void *data){return 0;};
 GLint gluBuild3DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const void *data){return 0;};
 GLboolean gluCheckExtension (const GLubyte *extName, const GLubyte *extString){return true;};
 void gluCylinder (GLUquadric* quad, GLdouble base, GLdouble top, GLdouble height, GLint slices, GLint stacks){};
 void gluDeleteNurbsRenderer (GLUnurbs* nurb){};
 void gluDeleteQuadric (GLUquadric* quad){};
 void gluDeleteTess (GLUtesselator* tess){};
 void gluDisk (GLUquadric* quad, GLdouble inner, GLdouble outer, GLint slices, GLint loops){};
 void gluEndCurve (GLUnurbs* nurb){};
 void gluEndPolygon (GLUtesselator* tess){};
 void gluEndSurface (GLUnurbs* nurb){};
 void gluEndTrim (GLUnurbs* nurb){};
 const GLubyte * gluErrorString (GLenum error){return 0;};
 void gluGetNurbsProperty (GLUnurbs* nurb, GLenum property, GLfloat* data){};
 const GLubyte * gluGetString (GLenum name){return 0;};
 void gluGetTessProperty (GLUtesselator* tess, GLenum which, GLdouble* data){};
 void gluLoadSamplingMatrices (GLUnurbs* nurb, const GLfloat *model, const GLfloat *perspective, const GLint *view){};
 void gluLookAt (GLdouble eyeX, GLdouble eyeY, GLdouble eyeZ, GLdouble centerX, GLdouble centerY, GLdouble centerZ, GLdouble upX, GLdouble upY, GLdouble upZ){};
 GLUnurbs* gluNewNurbsRenderer (void){return 0;};
 GLUquadric* gluNewQuadric (void){return 0;};
 GLUtesselator* gluNewTess (void){return 0;};
 void gluNextContour (GLUtesselator* tess, GLenum type){};
 void gluNurbsCallback (GLUnurbs* nurb, GLenum which, _GLUfuncptr CallBackFunc){};
 void gluNurbsCallbackData (GLUnurbs* nurb, GLvoid* userData){};
 void gluNurbsCallbackDataEXT (GLUnurbs* nurb, GLvoid* userData){};
 void gluNurbsCurve (GLUnurbs* nurb, GLint knotCount, GLfloat *knots, GLint stride, GLfloat *control, GLint order, GLenum type){};
 void gluNurbsProperty (GLUnurbs* nurb, GLenum property, GLfloat value){};
 void gluNurbsSurface (GLUnurbs* nurb, GLint sKnotCount, GLfloat* sKnots, GLint tKnotCount, GLfloat* tKnots, GLint sStride, GLint tStride, GLfloat* control, GLint sOrder, GLint tOrder, GLenum type){};
 void gluOrtho2D (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top){};
 void gluPartialDisk (GLUquadric* quad, GLdouble inner, GLdouble outer, GLint slices, GLint loops, GLdouble start, GLdouble sweep){};
 void gluPerspective (GLdouble fovy, GLdouble aspect, GLdouble zNear, GLdouble zFar){};
 void gluPickMatrix (GLdouble x, GLdouble y, GLdouble delX, GLdouble delY, GLint *viewport){};
 GLint gluProject (GLdouble objX, GLdouble objY, GLdouble objZ, const GLdouble *model, const GLdouble *proj, const GLint *view, GLdouble* winX, GLdouble* winY, GLdouble* winZ){return 0;};
 void gluPwlCurve (GLUnurbs* nurb, GLint count, GLfloat* data, GLint stride, GLenum type){};
 void gluQuadricCallback (GLUquadric* quad, GLenum which, _GLUfuncptr CallBackFunc){};
 void gluQuadricDrawStyle (GLUquadric* quad, GLenum draw){};
 void gluQuadricNormals (GLUquadric* quad, GLenum normal){};
 void gluQuadricOrientation (GLUquadric* quad, GLenum orientation){};
 void gluQuadricTexture (GLUquadric* quad, GLboolean texture){};
 GLint gluScaleImage (GLenum format, GLsizei wIn, GLsizei hIn, GLenum typeIn, const void *dataIn, GLsizei wOut, GLsizei hOut, GLenum typeOut, GLvoid* dataOut){return 0;};
 void gluSphere (GLUquadric* quad, GLdouble radius, GLint slices, GLint stacks){};
 void gluTessBeginContour (GLUtesselator* tess){};
 void gluTessBeginPolygon (GLUtesselator* tess, GLvoid* data){};
 void gluTessCallback (GLUtesselator* tess, GLenum which, _GLUfuncptr CallBackFunc){};
 void gluTessEndContour (GLUtesselator* tess){};
 void gluTessEndPolygon (GLUtesselator* tess){};
 void gluTessNormal (GLUtesselator* tess, GLdouble valueX, GLdouble valueY, GLdouble valueZ){};
 void gluTessProperty (GLUtesselator* tess, GLenum which, GLdouble data){};
 void gluTessVertex (GLUtesselator* tess, GLdouble *location, GLvoid* data){};
 GLint gluUnProject (GLdouble winX, GLdouble winY, GLdouble winZ, const GLdouble *model, const GLdouble *proj, const GLint *view, GLdouble* objX, GLdouble* objY, GLdouble* objZ){return 0;};
 GLint gluUnProject4 (GLdouble winX, GLdouble winY, GLdouble winZ, GLdouble clipW, const GLdouble *model, const GLdouble *proj, const GLint *view, GLdouble near, GLdouble far, GLdouble* objX, GLdouble* objY, GLdouble* objZ, GLdouble* objW){return 0;};


/* GLUT initialization sub-API. */
 void  glutInit(int *argcp, char **argv){};
 void  glutInitDisplayMode(unsigned int mode){};
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
 void  glutInitDisplayString(const char *string){};
//#endif
 void  glutInitWindowPosition(int x, int y){};
 void  glutInitWindowSize(int width, int height){};

void  glutMainLoop(void){
  
  while (true) {
	/* Make sure idle func still exists! */	
	if (__glutIdleFunc) {
	  __glutIdleFunc();
    }
	
  }
  
};

/* GLUT window sub-API. */
 int  glutCreateWindow(const char *title){return 0;};
 int  glutCreateSubWindow(int win, int x, int y, int width, int height){return 0;};
 void  glutDestroyWindow(int win){};
 void  glutPostRedisplay(void){};
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 11)
 void  glutPostWindowRedisplay(int win){};
//#endif
 void  glutSwapBuffers(void){};
 int  glutGetWindow(void){return 0;};
 void  glutSetWindow(int win){};
 void  glutSetWindowTitle(const char *title){};
 void  glutSetIconTitle(const char *title){};
 void  glutPositionWindow(int x, int y){};
 void  glutReshapeWindow(int width, int height){};
 void  glutPopWindow(void){};
 void  glutPushWindow(void){};
 void  glutIconifyWindow(void){};
 void  glutShowWindow(void){};
 void  glutHideWindow(void){};
//#if(GLUT_API_VERSION >= 3)
 void  glutFullScreen(void){};
 void  glutSetCursor(int cursor){};
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
 void  glutWarpPointer(int x, int y){};
//#endif

/* GLUT overlay sub-API. */
 void  glutEstablishOverlay(void){};
 void  glutRemoveOverlay(void){};
 void  glutUseLayer(GLenum layer){};
 void  glutPostOverlayRedisplay(void){};
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 11)
 void  glutPostWindowOverlayRedisplay(int win){};
//#endif
 void  glutShowOverlay(void){};
 void  glutHideOverlay(void){};
//#endif

/* GLUT menu sub-API. */
 int  glutCreateMenu(void (*)(int)){return 0;};
 void  glutDestroyMenu(int menu){};
 int  glutGetMenu(void){return 0;};
 void  glutSetMenu(int menu){};
 void  glutAddMenuEntry(const char *label, int value){};
 void  glutAddSubMenu(const char *label, int submenu){};
 void  glutChangeToMenuEntry(int item, const char *label, int value){};
 void  glutChangeToSubMenu(int item, const char *label, int submenu){};
 void  glutRemoveMenuItem(int item){};
 void  glutAttachMenu(int button){};
 void  glutDetachMenu(int button){};

/* GLUT window callback sub-API. */
 void  glutDisplayFunc(void (*func)(void)){};
 void  glutReshapeFunc(void (*func)(int width, int height)){};
 void  glutKeyboardFunc(void (*func)(unsigned char key, int x, int y)){};
 void  glutMouseFunc(void (*func)(int button, int state, int x, int y)){};
 void  glutMotionFunc(void (*func)(int x, int y)){};
 void  glutPassiveMotionFunc(void (*func)(int x, int y)){};
 void  glutEntryFunc(void (*func)(int state)){};
 void  glutVisibilityFunc(void (*func)(int state)){};
 void  glutIdleFunc(void (*func)(void))
{
  __glutIdleFunc = func;
};

 void  glutTimerFunc(unsigned int millis, void (*func)(int value), int value){};
 void  glutMenuStateFunc(void (*func)(int state)){};
//#if(GLUT_API_VERSION >= 2)
 void  glutSpecialFunc(void (*func)(int key, int x, int y)){};
 void  glutSpaceballMotionFunc(void (*func)(int x, int y, int z)){};
 void  glutSpaceballRotateFunc(void (*func)(int x, int y, int z)){};
 void  glutSpaceballButtonFunc(void (*func)(int button, int state)){};
 void  glutButtonBoxFunc(void (*func)(int button, int state)){};
 void  glutDialsFunc(void (*func)(int dial, int value)){};
 void  glutTabletMotionFunc(void (*func)(int x, int y)){};
 void  glutTabletButtonFunc(void (*func)(int button, int state, int x, int y)){};
//#if(GLUT_API_VERSION >= 3)
 void  glutMenuStatusFunc(void (*func)(int status, int x, int y)){};
 void  glutOverlayDisplayFunc(void (*func)(void)){};
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
 void  glutWindowStatusFunc(void (*func)(int state)){};
//#endif
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 13)
 void  glutKeyboardUpFunc(void (*func)(unsigned char key, int x, int y)){};
 void  glutSpecialUpFunc(void (*func)(int key, int x, int y)){};
 void  glutJoystickFunc(void (*func)(unsigned int buttonMask, int x, int y, int z), int pollInterval){};
//#endif
//#endif
//#endif

/* GLUT color index sub-API. */
 void  glutSetColor(int, GLfloat red, GLfloat green, GLfloat blue){};
 GLfloat  glutGetColor(int ndx, int component){return 0;};
 void  glutCopyColormap(int win){};

/* GLUT state retrieval sub-API. */
 int  glutGet(GLenum type){return 0;};
 int  glutDeviceGet(GLenum type){return 0;};
//#if(GLUT_API_VERSION >= 2)
/* GLUT extension support sub-API */
 int  glutExtensionSupported(const char *name){return 0;};
//#endif
//#if(GLUT_API_VERSION >= 3)
 int  glutGetModifiers(void){return 0;};
 int  glutLayerGet(GLenum type){return 0;};
//#endif

/* GLUT font sub-API */
 void  glutBitmapCharacter(void *font, int character){};
 int  glutBitmapWidth(void *font, int character){return 0;};
 void  glutStrokeCharacter(void *font, int character){};
 int  glutStrokeWidth(void *font, int character){return 0;};
//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
 int  glutBitmapLength(void *font, const unsigned char *string){return 0;};
 int  glutStrokeLength(void *font, const unsigned char *string){return 0;};
//#endif

/* GLUT pre-built models sub-API */
 void  glutWireSphere(GLdouble radius, GLint slices, GLint stacks){};
 void  glutSolidSphere(GLdouble radius, GLint slices, GLint stacks){};
 void  glutWireCone(GLdouble base, GLdouble height, GLint slices, GLint stacks){};
 void  glutSolidCone(GLdouble base, GLdouble height, GLint slices, GLint stacks){};
 void  glutWireCube(GLdouble size){};
 void  glutSolidCube(GLdouble size){};
 void  glutWireTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings){};
 void  glutSolidTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings){};
 void  glutWireDodecahedron(void){};
 void  glutSolidDodecahedron(void){};
 void  glutWireTeapot(GLdouble size){};
 void  glutSolidTeapot(GLdouble size){};
 void  glutWireOctahedron(void){};
 void  glutSolidOctahedron(void){};
 void  glutWireTetrahedron(void){};
 void  glutSolidTetrahedron(void){};
 void  glutWireIcosahedron(void){};
 void  glutSolidIcosahedron(void){};

//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
/* GLUT video resize sub-API. */
 int  glutVideoResizeGet(GLenum param){return 0;};
 void  glutSetupVideoResizing(void){};
 void  glutStopVideoResizing(void){};
 void  glutVideoResize(int x, int y, int width, int height){};
 void  glutVideoPan(int x, int y, int width, int height){};

/* GLUT debugging sub-API. */
 void  glutReportErrors(void){};
//#endif

//#if(GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 13)
/* GLUT device control sub-API. */
/* glutSetKeyRepeat modes. */
#define GLUT_KEY_REPEAT_OFF		0
#define GLUT_KEY_REPEAT_ON		1
#define GLUT_KEY_REPEAT_DEFAULT		2

/* Joystick button masks. */
#define GLUT_JOYSTICK_BUTTON_A		1
#define GLUT_JOYSTICK_BUTTON_B		2
#define GLUT_JOYSTICK_BUTTON_C		4
#define GLUT_JOYSTICK_BUTTON_D		8

 void  glutIgnoreKeyRepeat(int ignore){};
 void  glutSetKeyRepeat(int repeatMode){};
 void  glutForceJoystickFunc(void){};

/* GLUT game mode sub-API. */
/* glutGameModeGet. */
#define GLUT_GAME_MODE_ACTIVE           0
#define GLUT_GAME_MODE_POSSIBLE         1
#define GLUT_GAME_MODE_WIDTH            2
#define GLUT_GAME_MODE_HEIGHT           3
#define GLUT_GAME_MODE_PIXEL_DEPTH      4
#define GLUT_GAME_MODE_REFRESH_RATE     5
#define GLUT_GAME_MODE_DISPLAY_CHANGED  6

 void  glutGameModeString(const char *string){};
 int  glutEnterGameMode(void){return 0;};
 void  glutLeaveGameMode(void){};
 int  glutGameModeGet(GLenum mode){return 0;};
//#endif

/* General MUI Routines */

void	    muiInit(void){};
void        muiAttachUIList(int uilist){};
void	    muiNewUIList(int  listid){};
void	    muiAddToUIList(int  uilist, muiObject *obj){};
void	    muiSetCallback(muiObject *obj, void (*callback)(muiObject *, enum muiReturnValue)){};
void	    muiGetObjectSize(muiObject *obj, int *xmin, int *ymin, int *xmax, int *ymax){};
void	    muiSetID(muiObject *obj, int id){};
int	    muiGetID(muiObject *obj){return 0;};

/* for a click that doesn't hit anything: */

void	    muiSetNonMUIcallback(void (*nc)(int, int)){};

int	    muiGetVisible(muiObject *obj){return 0;};
void	    muiSetVisible(muiObject *obj, int state){};
int	    muiGetActive(muiObject *obj){return 0;};
void	    muiSetActive(muiObject *obj, int state){};
int	    muiGetEnable(muiObject *obj){return 0;};
void	    muiSetEnable(muiObject *obj, int state){};
void	    muiSetActiveUIList(int i){};
int	    muiGetActiveUIList(void){return 0;};

/* Button Routines */

muiObject   *muiNewButton(int xmin, int xmax, int ymin, int ymax){return 0;};
void	    muiLoadButton(muiObject *but, char *str){};
muiObject   *muiNewRadioButton(int xmin, int ymin){return 0;};
muiObject   *muiNewTinyRadioButton(int xmin, int ymin){return 0;};
void	    muiLinkButtons(muiObject *obj1, muiObject *obj2){};
void	    muiClearRadio(muiObject *rad){};

/* Label Routines */

muiObject   *muiNewLabel(int xmin, int ymin, char *label){return 0;};
muiObject   *muiNewBoldLabel(int xmin, int ymin, char *label){return 0;};
void	    muiChangeLabel(muiObject *obj, char *s){};

/* Text Box Routines */

muiObject   *muiNewTextbox(int xmin, int xmax, int ymin){return 0;};
char	    *muiGetTBString(muiObject *obj){return 0;};
void	    muiClearTBString(muiObject *obj){};
void	    muiSetTBString(muiObject *obj, char *s){};

/* Vertical Slider Routines */

muiObject   *muiNewVSlider(int xmin, int ymin, int ymax, int scenter, int shalf){return 0;};
float	    muiGetVSVal(muiObject *obj){return 0;};
void	    muiSetVSValue(muiObject *obj, float val){};
void	    muiSetVSArrowDelta(muiObject *obj, int newd){};

/* Horizontal Slider Routines */

muiObject   *muiNewHSlider(int xmin, int ymin, int xmax, int scenter, int shalf){return 0;};
float	    muiGetHSVal(muiObject *obj){return 0;};
void	    muiSetHSValue(muiObject *obj, float val){};
void	    muiSetHSArrowDelta(muiObject *obj, int newd){};

/* Text List Routines */

muiObject   *muiNewTextList(int xmin, int ymin, int xmax, int listheight){return 0;};
void	    muiSetTLTop(muiObject *obj, float p){};
int	    muiGetTLSelectedItem(muiObject *obj){return 0;};
void	    muiSetTLStrings(muiObject *obj, char **s){};
void	    muiSetTLTopInt(muiObject *obj, int top){};

/* Pulldown Menu Routines */

muiObject   *muiNewPulldown(void){return 0;};
void	    muiAddPulldownEntry(muiObject *obj, char *title, int menu, int ishelp){};

#endif
