#include "world.h"
#include "robot.h"

bool at_least_one_crash = false;

void world::set_environment(environment & _env) 
{
  env= & _env;
  //env->initGL3D(); //old way to init GL for environment

  // Place Robots in the new env
  for (vector<robot*>::iterator it1=vector_robot.begin();it1!=vector_robot.end();it1++) 
		{
		  (*it1)->choose_a_place(env->dx,env->dy);
		}
}

void world::add_robot(class robot & _robot) 
{
  _robot.set_world(this); // to say to the robot where is the world
  vector_robot.push_back(& _robot); // store the robot in this world

  if (env!=NULL) {
  _robot.choose_a_place(env->dx,env->dy); // let the robot choose a position (if random start)
  }

  
  // _robot.robot_GL3D(); //old way to init GL for robots
  
  int win = glutGetWindow();
  
  glutSetWindow(winIdSensors);
  glutReshapeWindow((int)Math::Floor(size_of_win_sensors*1.1*(min<unsigned>(vector_robot.size(),MAX_ROBOTS_BY_LINE))),(int) size_of_win_sensors*(Math::Ceil((float)vector_robot.size()/MAX_ROBOTS_BY_LINE)));
  
  glutSetWindow(win);
  
}

void world::evolue()
	{
	  int i=0;
	  vector<robot*>::iterator it1;
	  
	  for (it1=vector_robot.begin();it1!=vector_robot.end();it1++) 
		{
		  
		  // Reset sensors
		  (*it1)->reset_sensors();
		  //cout << "evo2" << endl;
		  // Ask the Robots to take a decision except if user have a take over
		  if (!(take_over==i)) {(*it1)->take_a_decision();}
		  i++;
		  
		}

	  
	  
	  // Reset all crash sensors
	  for (it1=vector_robot.begin();it1!=vector_robot.end();it1++) 
		{
		  (*it1)->reset_crash_sensors();
		}
	  
	  if (use_real_khepera)
		{
		  i=0;
		  for (it1=vector_robot.begin();it1!=vector_robot.end();it1++) 
			{
			  (*it1)->real_move();
			}
		}
	  else
		{
		  // Execute decisions ( "update position" also set crash sensors)
		  i=0;
		  for (it1=vector_robot.begin();it1!=vector_robot.end();it1++) 
			{
			  (*it1)->update_position();
			  // if take_over Reset decision
			  //if (take_over==i) {(*it1)->decide_to_stop();}
			  i++;
			}
		}
	  
	  simulated_time+=cycle_simulation;	  // Sands of time ;-)
	}

  // to acces private data of world : shift to apply to the world to have a centered representation

float world::gl_shift_cam_x()
	{
	  return (env->gl_shift_cam_x);	  
	}

float world::gl_shift_cam_y()
	{
	  return (env->gl_shift_cam_y);	  
	}

/*
void world::initGL3D()
{

  // robot initialisation
  for (vector<robot*>::iterator it1=vector_robot.begin();it1!=vector_robot.end();it1++) 
	{
	  (*it1)->robot_GL3D();
	}
  
  // environment initialisation
  
  env->initGL3D();
  
}
  */

  
void world::display_2D()
{
  // robot.display_2D
  	  
  for (vector<robot*>::iterator it1=vector_robot.begin();it1!=vector_robot.end();it1++) 
		{
		  (*it1)->display_2D();
		}
	  
	  
  // environnement.display_2D
  if (env!=NULL)
	{
	  env->display_2D();
	}
  
	  
}
  
void world::display_3D()
	{
	  // robot.display_3D

	  for (vector<robot*>::iterator it1=vector_robot.begin();it1!=vector_robot.end();it1++) 
		{
		  (*it1)->display_3D();
		}
	  
	  // environnement.display_3D
	  if (env!=NULL)
		{
		  env->display_3D();
		}
	  
	  
	}
  
void world::display_winSensors()
	{
	  // robot.display_3D
	  int i=0;
	  for (vector<robot*>::iterator it1=vector_robot.begin();it1!=vector_robot.end();it1++) 
		{
		  (*it1)->display_winSensors(((Real)(i%MAX_ROBOTS_BY_LINE))*1.1,Math::Floor(i/MAX_ROBOTS_BY_LINE));
		  i++;
		}
	  
	}

void world::Register_my_restart_func(void (* func) (robot * r) )
{
  my_restart_func=func;
}



void world::reset_robots_positions()
{
  for (vector<robot*>::iterator it1=vector_robot.begin();it1!=vector_robot.end();it1++) 
    {
	  
      if ((my_restart_func!=NULL)) {
		my_restart_func(*it1);
		//altern_position(*it1);
		//cout << "Fixed postion" <<endl;
	  } //Parameter for EO visualisation if '=' is activated so the position change if there are different assigned positions
      else {(*it1)->choose_a_place(env->dx,env->dy);cout << "Random position"<<endl;}
	  
    }
}






