//Time-stamp: <2004-04-05 10:53:26 mary>
/*  
 *

 *
 */

//Classics headers
#include <iostream>

//Environment, Robot,  Word and Controllers headers
#include "../../src/heart/simulator.h"

// To use time to initialise Random number generator
#include <time.h>


#define MAX_STORED_STATES 100000

bool operator_control=false;
bool say_to_increase_Vrot=false;
bool say_to_decrease_Vrot=false;
bool reset_Vrot=false;
bool estimate_distribution=false;


//We prepare a function to manage keys hitted during simulation
// c is the char received
// (x,y) the position of the mouse in the window
void my_key_func(unsigned char c, int x, int y)
{

  //  
  switch (c){
  case 'o' :
	if (operator_control) {
	  estimate_distribution=true;
	  }
	
	operator_control=!operator_control; break;
	
  case ';' : say_to_decrease_Vrot=true; break;
  case ':': say_to_increase_Vrot=true; break;

  case '=': world_GL.reset_robots_positions();
	reset_Vrot=true;
	
	break;
	
  default:
	cout<<"You hitted --"<<c<<"-- with mouse at :"<<x<<","<<y<<endl;
	break;
	
  };
  
  
}






class Etat
{
public:

  Etat(Real * _sensor)
  {
	Lum = 0;
	Real vLum=_sensor[8];
	
	Real vProx=_sensor[0];

	for (int i = 0;i<8;i++)
	  {
		IR[i]=_sensor[i];
		L[i]=_sensor[i+8];
		if (vLum<L[i]) {vLum=L[i]; Lum=i;}
		if (vProx<IR[i]) {vProx=IR[i]; }
		
	  }

	Prox=(int)Math::Floor(vProx/16);

	Direc=(int)Math::Floor((-90*_sensor[0]-45*_sensor[1]-5*_sensor[2]+5*_sensor[3]+45*_sensor[4]+90*_sensor[5])/(9*(_sensor[0]+_sensor[1]+_sensor[2]+_sensor[3]+_sensor[4]+_sensor[5]))+1);
	
	Vrot=(int)_sensor[16];
	
	
  }

  void display(){
	/*	for (int i = 0;i<8+8;i++)
	  {
		cout<<IR[i]<<" "<<L[8]<<" ";
	  }
	  cout<<endl;*/
	cout<<Lum<<" "<<Direc<<" "<<Prox<<" "<<Vrot<<endl;
	
  }
  
  
  Real IR[8];
  Real L[8];
  int Direc;
  int Prox;
  int Vrot;
  int Lum;
  
  
};



class Memory
{
public :
  Memory()
  {}
  void add_etat(Real * _IR)
  {
	vector_of_etats.push_back(new Etat(_IR));
	
	if (vector_of_etats.size()>MAX_STORED_STATES)
	  {
		vector_of_etats.erase(vector_of_etats.begin());
	  }
	
  }
  int number_of_etats()
  {
	return vector_of_etats.size();
  }
  
  
  void print_all_etats()
  {
	for (vector<Etat*>::iterator it1=vector_of_etats.begin();it1!=vector_of_etats.end();it1++) 
		  {
			(*it1)->display();
		  }
  }

  void estimate_Vrot_distribution()
  {
	cout<<"estimating Vrot with "<<vector_of_etats.size()<<" time steps" <<endl;
	
	int mv[21][21][16];
	int mdp[21][16];
	
	int i,j,k;
	for (i=0;i<21;i++){
	  for (j=0;j<16;j++){mdp[i][j]=0;
	  for (k=0;k<21;k++){mv[k][i][j]=0;}}
	}
	
	
	for (vector<Etat*>::iterator it1=vector_of_etats.begin();it1!=vector_of_etats.end();it1++) 
	  {
		mv[(*it1)->Vrot+10][(*it1)->Direc+10][(*it1)->Prox]++;
		mdp[(*it1)->Direc+10][(*it1)->Prox]++;
	  }

	for (k=0;k<21;k++){
	  for (i=0;i<21;i++){
		for (j=0;j<16;j++){
		  Vrot_distribution[k][i][j]=((Real)mv[k][i][j]+1)/((Real)mdp[i][j]+21);
		  //cout<<Vrot_distribution[k][i][j]<<" "<<endl;
		  //if (Vrot_distribution[k][i][j]>0.1) {cout<<k<<" "<<i<<" "<<j<<endl;}
		  
		  
		  }
	  }
	}
	
  }

  int more_probable_Vrot(int d,int p)
  {
	int i;
	int vrot=0;
	Real proba=0;
	
	for (i=0;i<21;i++)
	  {
		if (Vrot_distribution[i][d+10][p]>proba) {
		  proba=Vrot_distribution[i][d+10][p];
		  vrot=i-10;
		  // cout<<vrot<<endl;
		  
		  }
		
	  }
	return vrot;
  }
  

  ~Memory()
  {
	for (vector<Etat*>::iterator it1=vector_of_etats.begin();it1!=vector_of_etats.end();it1++) 
		  {
			delete (*it1);
		  }
  }
  
private :
  vector<Etat *> vector_of_etats;
  Real Vrot_distribution[21][21][16];
  
  //  vector<Action *> vector_of_actions;
  
};


// definition of our khepera with memory
class khepera_M: public khepera
{
public:
  // here are the 2 standards constructors of khepera - you can modify it but keep in mind that you have to call a constructor of khepera in each of your constructors
  khepera_M(string _namerobot, Controller * _controller_base, Real _radius=27.5) : khepera(_namerobot,_controller_base,_radius)
  {memory=new Memory();
  Vrot=0;}
  khepera_M(string _namerobot, Controller * _controller_base, Real _centerx, Real _centery, Real _direction, Real _radius=27.5) : khepera(_namerobot,_controller_base,_centerx,_centery,_direction,_radius)
  {memory=new Memory();
  Vrot=0;}

  void add_etat(Real * _IR)
  {
	memory->add_etat(_IR);
  }
  void print_all_etats()
  {
	memory->print_all_etats();
  }
  int number_of_etats()
  {
	return memory->number_of_etats();
  }

  void estimate_Vrot_distribution()
  {
	 memory->estimate_Vrot_distribution();
  }
  
  int more_probable_Vrot(int d,int p)
  {
	return memory->more_probable_Vrot(d,p);
  }
  
  ~khepera_M() // destructor
  { //add here the destructors of the things that you added to your khepera
	delete memory;
	
	// you NEVER need to modify the destructor beyond this point (it is a call to the destructor of khepera)
	Partial_self_destruct();
  }
  
  Real Vrot;

private:
  class Memory *  memory;
  
};




void simple_khepera_controller (robot & _myrobot) 
	 
{
  
#ifdef _WIN32
  khepera_M * myrobot =(static_cast<khepera_M *>(& _myrobot));
#else
  khepera_M * myrobot =(dynamic_cast<khepera_M *>(& _myrobot));
#endif
  
  if (reset_Vrot) {
	myrobot->Vrot=0;
	reset_Vrot=false;
  }
  
  if (estimate_distribution){
	myrobot->estimate_Vrot_distribution();
	estimate_distribution=false;
	}
  
  
  //  if (myrobot->crash_obstacle) {cout<<"crash on obstacle"<<endl; }
  //if (myrobot->crash_other_robot) {cout<<"crash on robot"<<endl; }
  //if (myrobot->crash_obstacle_unfixed) {cout<<"crash on an unfixed object"<<endl; }
  //if (myrobot->on_food)  {
	//Detect if robot is on food (food allow to eat)
  //	if (myrobot->eat()) {cout<<"miam-miam"<<endl;}
  //}

  if (operator_control){
	if (say_to_increase_Vrot){
	  say_to_increase_Vrot=false;
	  myrobot->Vrot=myrobot->Vrot+1;
	  }

	if (say_to_decrease_Vrot){
	  say_to_decrease_Vrot=false;
	  myrobot->Vrot=myrobot->Vrot-1;
	  }

	   
	Real IR[8+8+1];
	for (int i=0;i<8;i++){
	  IR[i]=myrobot->IR(i);
	}

	for (int i=8;i<16;i++){
	  IR[i]=myrobot->IR_passive(i-8);
	}

	IR[16]=myrobot->Vrot;
  
	myrobot->add_etat(IR);
	/*
	if (myrobot->number_of_etats()==500)
	  {
		myrobot->print_all_etats();
		}*/
	
	  
  }else{

	Real _sensor[8+8+1];
	for (int i=0;i<8;i++){
	  _sensor[i]=myrobot->IR(i);
	}

	for (int i=8;i<16;i++){
	  _sensor[i]=myrobot->IR_passive(i-8);
	}

	_sensor[16]=myrobot->Vrot;
  
	Real vProx=_sensor[0];
	for (int i = 0;i<8;i++)
	  {
		if (vProx<_sensor[i]) {vProx=_sensor[i]; }
	  }
	int Prox=(int)Math::Floor(vProx/16);

	int Direc=(int)Math::Floor((-90*_sensor[0]-45*_sensor[1]-5*_sensor[2]+5*_sensor[3]+45*_sensor[4]+90*_sensor[5])/(9*(_sensor[0]+_sensor[1]+_sensor[2]+_sensor[3]+_sensor[4]+_sensor[5]))+1);

	myrobot->Vrot=myrobot->more_probable_Vrot(Direc,Prox);
	
  }
  
 myrobot->decision.left_motor= (20+myrobot->Vrot)/30; 
 myrobot->decision.right_motor=(20-myrobot->Vrot)/30;

  
};

extern world world_GL;  // this is the world used by the main function and the main Display function for openGL


int main (int argc, char *argv[]) // int argc, char *argv[ ], char *envp[ ] )
{
  srand(time(NULL)); //random generator initialisation

  cycle_simulation=0.012;

  if (GL_world_initialisation(argc,argv,640,480,80)==1) {return 1; }//error with OpenGL
  
  //We register our callback function for keys management (Optionnal)
  Register_my_keyfunc(my_key_func);
  

  
  //secondly, we add the parameters for the environment and for the robots
  try	
	{
	  const int WIDTH  = 600;
	  const int LENGTH = 700;
	  
	  
      environment env0(WIDTH,LENGTH);// The two numbers are the size of the environment (in mm)


      env0.add_wall("wall0",0.0,0.0,0.0,LENGTH,unsigned(255));
      env0.add_wall("wall1",0.0,0.0,WIDTH,0.0,unsigned(255));
	  env0.add_wall("wall2",0.0,LENGTH,WIDTH,LENGTH,unsigned(255));
      env0.add_wall("wall3",WIDTH,0.0,WIDTH,LENGTH,unsigned(255));
      
	  // save way to add two obstacles (there is a method add_cylinder too)
      //env0.add_cylinder_unfixed("cylinder_unfixed0",200.0,150.0,25.0,unsigned(200)); //this obstacle is unfixed (can move)
	  env0.add_bloc("bloc1",300.0,350.0,100.0,0.0,0.0,100.0,unsigned(255));

	  
	  //env0.add_food(100,300);
	  //env0.add_food(100,200);
	  
	  
	  // You can make a save of your environment :
	  // env0.save("bloc_center.env");
	  //
	  // And you can load it using this constructor
	  // environment env1("test_env_sav.sav");


	  // Now we create a controller using the function previously defined
	  Controller *  ctrl=new Controller (simple_khepera_controller);

	  // You can declare the controller you want to use and give them a name
	  // This is optionnal in a normal use (except if you plan to use EO)
	  all_the_controllers.add_a_controller("controller_khepera_simple",ctrl);
	  
	  
	  khepera_M myfirstkhepera ("first",all_the_controllers("controller_khepera_simple"),300.0,100.0,M_PI/2);
	  // This robot have a fixed start and direction (direction is given in radian M_PI/2 is North)

	  //	  myfirstkhepera.add_1D_cam();
	  

	  // Now we set the environment of the world
	  world_GL.set_environment(env0);
	  // And we add the robots 
	  world_GL.add_robot(myfirstkhepera);
	  //world_GL.add_robot(mysecondkhepera); 

	 //Do not forget to add cams to the robots

	  
	  // main loop (only if you whish to use OPENG_GL display)
	  // See Glut Documentation (you will nevet get back from this function)
	  glutMainLoop();
	  
	  return 0;
		
	}
  
  // optionnal gestion of exceptions may help you...
  catch (error & _error)
	
	{
	  _error.what();
	}
  
  return 0;
  
  }
  



