//Time-stamp: <2004-04-29 12:28:23 mary>
/*  
 *

 *
 */

#include "../../config.h"

#ifdef HAVE_PTHREAD

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/un.h>
#include <stdio.h>
#include <iostream>

#define MAXLINE      1024
#define MASOCKET        1050
//si l'acces est refuse, essayer avec un socket > 1023 (ex: 1111)

using namespace std;

// Write in socket from sendline. Stops when
// MAXLINE char written or when char is '\0'
bool my_write(const int sockfd, const char sendline[MAXLINE])
{
  int count=0;
  
  while ((count<MAXLINE)&&(sendline[count]!='\0'))
	{
	  count++;
	}
  
  if (count>0)
	{
	  if (send(sockfd,sendline,count,0)<0)
		{
		  return false;
		}
	}
  
  send(sockfd,"\0",1,0);
  
  return true;
  
  }

// Read in socket. Stops when
// MAXLINE char readed or when char is '\0'
// Readed chars are in received
bool my_read(const int sockfd, char recvline[MAXLINE+1])
{
  int count =0;
  bool stop =false;
  
  char recvchar[1];
  

  
  while ((count<MAXLINE)&&(!stop))
	{
	  if ((recv(sockfd, recvchar, 1,0))<=0) return false;
	  if (recvchar[0]=='\0') {stop=true;}
	  recvline[count]=recvchar[0];
	  count++;
	}
  recvline[count]='\0'; // to be sure to have a \0 somewhere (and to avoid buffer overflow)
  
  return true;
}


int                         
main(int argc, char **argv)
{
    int     sockfd;
    char        recvline[MAXLINE+1];
	char        sendline[MAXLINE];
	
    struct  sockaddr_in servaddr;

    if (argc != 2){
        perror("usage: a.out <IPaddress>");
		return 0;
		
		//        exit(1);                
//si le nombre de parametres n'est pas correct...

    }

    if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0){   
//la fonction socket cree un socket de flux (SOCK_STREAM)internet(AF_INET)
//(incomprehensible en francais)(plus simplement : Internet stream socket).
//Renvoit un int pour identifier le socket plus tard (cf. read & connect)

        perror("socket error");
		return 0;
		
		//        exit(1);
//si ca foire...
    }

    bzero(&servaddr, sizeof(servaddr)); 
//on met toute la structure a 0
//on remplit la structure avec l'ip du serveur et le num de son port

    servaddr.sin_family = AF_INET;
    servaddr.sin_port    = htons(MASOCKET);
//htons: pour convertir le numero de port

    if (inet_pton(AF_INET, argv[1], &servaddr.sin_addr) <= 0){
//inet_pton: convertit l'argument ASCII (Ex: 127.0.0.1) dans le bon format

        perror("inet_pton error");
		return 0;
		
        // exit(1);
//de meme, si ca foire...
    }

    if (connect(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr)) < 0){
//connect etablit la connection TCP avec le serveur specifie par la structure de
//l'adresse du socket pointe par le second argument

        perror("connect error");
		return 0;

		
		
		//   exit(1);
//idem
    }

	my_read(sockfd, recvline); 
	cout<<"Connected to the simulator. Control of robot : \" ";
	fputs(recvline, stdout);
	cout<<" \""<<endl<<endl;

	while (1) {

	  // ask sensor values
	  sprintf(sendline,"N");

	  cout<<"Sending  : ";fputs(sendline, stdout); cout<<endl<<"Receiving : ";
	  

	  
	  my_write(sockfd, sendline); //ask
	  my_read(sockfd, recvline); // wait for response

	  fputs(recvline, stdout); //Display the received datas
	  cout<<endl<<endl;

	  	  
	  // elapsed simulation time request
	  sprintf(sendline,"S");


	  cout<<"Sending  : ";fputs(sendline, stdout); cout<<endl<<"Receiving : ";
	  
	  my_write(sockfd, sendline);
	  my_read(sockfd, recvline); // wait for confirmation 

	  fputs(recvline, stdout); //Display the received data
	  cout<<endl<<endl;
	  
	  
	  
	  //give a motor order
	  sprintf(sendline,"D,%i,%i",5,5);

	  cout<<"Sending  : "; fputs(sendline, stdout); cout<<endl<<"Receiving : ";
	  	  
	  my_write(sockfd, sendline);
	  my_read(sockfd, recvline); // wait for confirmation 

	  fputs(recvline, stdout); //Display the received data
	  cout<<endl<<endl;
	 
	  // ask where is food
	  sprintf(sendline,"P");
	  cout<<"Sending  : ";fputs(sendline, stdout); cout<<endl<<"Receiving : ";
	  
	  my_write(sockfd, sendline);
	  my_read(sockfd, recvline); // wait for confirmation 

	  fputs(recvline, stdout); //Display the received data
	  cout<<endl<<endl;
	 
	  // check if on food
	  sprintf(sendline,"O");
	  cout<<"Sending  : ";fputs(sendline, stdout); cout<<endl<<"Receiving : ";
	  
	  my_write(sockfd, sendline);
	  my_read(sockfd, recvline); // wait for confirmation 

	  fputs(recvline, stdout); //Display the received data
	  cout<<endl<<endl;
	 
	 
	 

	  // try to eat
	  sprintf(sendline,"G");
	  cout<<"Sending  : ";fputs(sendline, stdout); cout<<endl<<"Receiving : ";
	  
	  my_write(sockfd, sendline);
	  my_read(sockfd, recvline); // wait for confirmation 

	  fputs(recvline, stdout); //Display the received data
	  cout<<endl<<endl;
	 
	 	  
	  // Bad request (just a test)
	  sprintf(sendline,"Bad");
	  cout<<"Sending  : ";fputs(sendline, stdout); cout<<endl<<"Receiving : ";
	  
	  my_write(sockfd, sendline);
	  my_read(sockfd, recvline); // wait for confirmation 

	  fputs(recvline, stdout); //Display the received data
	  cout<<endl<<endl;
	  
	  
	  
	  //sleep(2);
	  
	  }
	
    
}

#else

#include <stdio.h>
int main()
{
#ifndef HAVE_PTHREAD
  cout<<"pthread library not found. Cannot launch WoB in server mode"<<endl;
#endif

#ifndef HAVE_SOCKET
  cout<<"socket library not found. Cannot launch WoB in server mode"<<endl;
#endif

  return 0;
}

#endif
