/** -*- mode: c++; c-indent-level: 4; c++-member-init-indent: 8; comment-column: 35; -*-

The above line is usefulin Emacs-like editors
 */

/*
Template for creating a new representation in EO
================================================
*/

#ifndef _eoRN_h
#define _eoRN_h

#include "global.h"
#ifndef DONT_USE_EO

#include <iostream>  // istream, ostream
#include "eoRNInclude.h"
#include "eoArchi.h"
#include "eoPersistent.h"
#include <eo>
#include "Real.h"
//#include "map_controllers.h"
class Controller;   
class robot;

double sigmoid(double entree);

double activationbraitenberg (double entree);


struct elem_robot

{

  vector<double> poids;
  vector<double> stDev;
  eoArchi * archi;
  unsigned NbPoids() {return poids.size();}
  double & operator[](unsigned i) {return poids[i];}
  Controller * controller;
  string string_controller;
  string type_of_robot;
  robot * pointer_on_the_robot;

};

/** 
 * Base genotype. is NOT an EO because it can be used alone 
 * in more complex constructs
 */
class eoRNGenotype: public eoRealFunction, public eoPersistent
{

public:
  /** Ctor: you MUST provide a default ctor.
   * though such individuals will generally be processed 
   * by some eoInit object
   */
  eoRNGenotype() 
  {}

  virtual string className() const { return "eoRNGenotype"; }

  /** Computing output from inputs: done by the architecture object */
  /*  vector<double> operator()(vector<double> & _v)  //To replace by compute
    {
     vector <double> output;
    
    archi->calcul(poids, _v, output);
    
    return output;
    }*/


vector<Real> compute (vector<Real> & _v, unsigned _robot_number)  //To replace by compute
  {
    vector <Real> output;
    
    robots[_robot_number].archi->calcul(robots[_robot_number].poids, _v, output);
    
    return output;
  }
  
  /** printing... */
  void printOn(ostream& os) const
        {
     unsigned i;
     os << number_of_robots << " ";
     for (unsigned a=0;a<number_of_robots;a++)
       {
    robots[a].archi->printOn(os);
    os << " " << robots[a].poids.size() << " " ;   // EO philosophy: always print size before vectors
    for (i=0; i<robots[a].poids.size(); i++)
     os << robots[a].poids[i] << " ";
    //     a modifier pour avoir poids[stDev] 
     for (i=0; i<robots[a].poids.size(); i++)
     os << robots[a].stDev[i] << " ";
       }
    }

  /** reading... 
   * of course, your readFrom must be able to read what printOn writes!!!
   */
  void readFrom(istream& is)
  {
    unsigned number_of_controllers;
    is >> number_of_controllers;

 robots.resize(number_of_controllers);
 number_of_robots=number_of_controllers;
    
    for (unsigned a=0;a<number_of_controllers;a++)
      {
    unsigned i;
    string s;
    is >> s;
    ////// GROS PROBLEME : ces pointeurs ne seront jamais detruits !!!!!
    

    if (s == string("MULTILAYER"))
  {
  robots[a].archi = new eoMultiLayer(is);
 }
  else if (s == string("FEEDFORWARD"))
    {
  robots[a].archi = new eoFeedForward(is);
    }
  else if (s == string("ELMAN"))
    {
  robots[a].archi = new eoRecurrentHidden(is);
    }

    else if (s == string("RECURRENTHIDDENTRIGGER"))
    {
  robots[a].archi = new eoRecurrentHiddenTrigger(is);
    }

   else if (s == string("AnticipationNetwork"))
    {
  robots[a].archi = new AnticipationNetwork(is);
    }
    
   else if (s == string("AnticipationNetworkBackprop"))
    {
  robots[a].archi = new AnticipationNetworkBackprop(is);
    }

  else	 
    throw breakerror("Pas la bonne architecture, sont disponibles les MULTILAYER, FEEDFORWARD, ELMAN, RECURRENTHIDDENTRIGGER, AnticipationNetwork, ANTICIPATIONNETWORKBACKPROP");
    // les poids
    unsigned nbp; 
    is >> nbp;
    
    if (nbp != robots[a].archi->NbPoids())
  {
  string serr = "Invalid number of weights when reading NN\n"; // add both numbers someday
  throw breakerror(serr);
    }
    
  robots[a].poids.resize(nbp);
 
  robots[a].stDev.resize(nbp);
 
   for (i=0; i<nbp; i++)
    is >> robots[a].poids[i];
 
  for (i=0; i<nbp; i++)
    is >> robots[a].stDev[i];
	

  }
 

  }

  

     
  

unsigned number_of_robots;
vector<elem_robot> robots;

  // vector<double> poids;     // les poids
  // vector<double> stDev;
  // eoArchi * archi;
};





///////////////////////////////////////////////////////////////////
/** Now the EO objects: the ARE an eoRNGenotype AND an EO object */
///////////////////////////////////////////////////////////////////
template <class FitT>
class eoRN : public EO<FitT>, public eoRNGenotype
{
public:
  virtual string className() const  { return "eoRN"; }

  /** printing... */
  void printOn(ostream& os) const
     {
    EO<FitT>::printOn(os);		   // prints the fitness
    
    eoRNGenotype::printOn(os);   // and genotype
    }
  
  
  //void affiche ();

/** reading... 
   * of course, your readFrom must be able to read what printOn writes!!!
   */
  void readFrom(istream& is)
    {
  EO<FitT>::readFrom(is);
  eoRNGenotype::readFrom(is);
  }
};

/// need to redefine these because of ambiguiti in multiple inheritance
ostream & operator << ( ostream& _os, const eoRNGenotype& _o );

// {
//_o.printOn(_os);
//return _os;
//}


istream & operator >> ( istream& _is, eoRNGenotype& _o );
// {
// _o.readFrom(_is);
// return _is;
//}


#endif
#endif
