#include "global.h"

#ifndef DONT_USE_EO
#include "robot.h"
#include "environment.h"

extern bool at_least_one_crash;  //If one robot is crashing, we can go directly to next epoch
extern bool new_epoch;  //If true, the epoch is just new (cycle=0)
extern bool draw_eo;
extern bool eo_activated;


Real explor_simple (vector<robot *> & _vector_robots,environment & _env)

{
#ifndef DONT_USE_EO
  
  at_least_one_crash=false;

#ifdef _WIN32
    khepera * khepera0 =(static_cast<khepera *>(_vector_robots[0]));
#else
	khepera * khepera0 =(dynamic_cast<khepera *>(_vector_robots[0]));
#endif
    //    typedef ((*_vector_robots)[0]) robot0;

    double fitness_per_cycle = 0.0;
    if (khepera0->crash_obstacle) 

      {
	
	fitness_per_cycle-=10000.0;
	at_least_one_crash=true;
	return fitness_per_cycle;

      }
    fitness_per_cycle+=khepera0->left_motor_speed+khepera0->right_motor_speed;
    //  fitness_per_cycle-=10*fabs(khepera0->left_motor_speed-khepera0->right_motor_speed);
    if (draw_eo && !eo_activated) 

      {
      cout << "Vitesses : " << khepera0->left_motor_speed << "  " << khepera0->right_motor_speed<< " fitness : " << fitness_per_cycle <<"                                      \r";
    
      }
//printf("Vit: %6.10f %6.10f",khepera0->left_motor_speed,khepera0->right_motor_speed);


    return fitness_per_cycle;
#else
	return 0.0;
	
#endif

}


Real explor_simple_all_kheperas (vector<robot *> & _vector_robots,environment & _env)

{
#ifndef DONT_USE_EO

  at_least_one_crash=false;
  vector <khepera *> vector_khepera(_vector_robots.size());
double fitness_per_cycle = 0.0;

  for (unsigned i=0;i<_vector_robots.size();i++)
    {
#ifdef _WIN32
    vector_khepera[i] =(static_cast<khepera *>(_vector_robots[i]));
#else
	vector_khepera[i] =(dynamic_cast<khepera *>(_vector_robots[i]));
#endif
    //    typedef ((*_vector_robots)[0]) robot0;
    
    if (vector_khepera[i]->crash_obstacle) 

      {
	
	fitness_per_cycle-=10000.0;
	at_least_one_crash=true;
	return fitness_per_cycle;

      }

    fitness_per_cycle+=vector_khepera[i]->left_motor_speed+vector_khepera[i]->right_motor_speed;
    }



    

    return fitness_per_cycle;
#else
	return 0.0;
	
#endif

}


/*! 
  *  \brief Fitness Function: Exploration of the lanzi maze,
  * *******************************************
  * *                                         *
  * *                                         *
  * *     *******     *******     *******     *
  * *     *     *     *     *     *     *     *
  * *     *     *     *     *     *     *     *
  * *     *     *     *     *     *     *     *
  * *     *     *     *     *     *     *     *
  * *     *     *     *     *     *     *     *
  * *  I  *     *  I  *     *  A  *     *  I  *
  * *******     *******     *******     *******
  * I=Initial Position
  * A=Arrival
  *  \version 1.0
  *  \date    September 2003
  *  \bug No
  *  \warning this fitness function is to associate with an appropriate parameter file, for example anticipation.param, it is not auto adaptative for the moment with the dimensions of the environment 
  */



static bool corridor_high=false; //For this fitness case, if corridor_high the robot has left one of the bottom corridor 


void harvey_display ()
{

  //  glutSetWindow(winIdMain);

  //glPushMatrix();
// glLoadIdentity();
  DrawRectangle3D(100.0/SCALE_GL, 100.0/SCALE_GL, 100.0/SCALE_GL, 300.0/SCALE_GL, 500.0/SCALE_GL, 0.0, 1.0, 0.0,1.0);
  //drawCylinder(500.0,50.0,20,1,true);
  //glutWireSphere(10.0,20,16);
  //glutWireSphere(10.0/SCALE_GL,20,16);
  // cout << "I'm here " << endl;

  //glPopMatrix();

}


Real explor_lanzi_maze (vector<robot *> & _vector_robots,environment & _env)

{
#ifndef DONT_USE_EO

 
  at_least_one_crash=false;
  
  khepera * khepera0 =(dynamic_cast<khepera *>(_vector_robots[0]));
    
  double fitness_per_cycle = 0.0;

  if (khepera0->crash_obstacle) 

      {
	
	fitness_per_cycle-=10000.0;
	at_least_one_crash=true;
	return fitness_per_cycle;

      }

 

  if (new_epoch) corridor_high=false;
  
  if (!corridor_high && khepera0->centery>70.0) {corridor_high=true;
} 
  
  fitness_per_cycle+=khepera0->left_motor_speed+khepera0->right_motor_speed;

  if (corridor_high)
    {

 if (khepera0->centerx>340.0 && khepera0->centerx<410.0 && khepera0->centery<50.0) {fitness_per_cycle+=20000.0;at_least_one_crash=true;
 if (at_least_one_crash && draw_eo) cout << "Ok ! Well done" << endl;
 } //at_lest_one_crash significates here end on the epoch 

 else if ((khepera0->centerx>0.0 && khepera0->centerx<70.0) &&  (khepera0->centery<50.0)) {fitness_per_cycle-= 5000.0;at_least_one_crash=true;} //at_lest_one_crash significates here end on the epoch 

 else if ((khepera0->centerx>170.0 && khepera0->centerx<240.0) &&  (khepera0->centery<50.0)) {fitness_per_cycle-= 5000.0;at_least_one_crash=true;} //at_lest_one_crash significates here end on the epoch 

 else if ((khepera0->centerx>510.0 && khepera0->centerx<580.0) &&  (khepera0->centery<50.0)) {fitness_per_cycle-= 5000.0;at_least_one_crash=true;} //at_lest_one_crash significates here end on the epoch 


 if (khepera0->centery<50.0) corridor_high = false;

    }

    if (new_epoch) new_epoch=false;


    if (draw_eo && !eo_activated) 

      {
      cout << "fitness : " << fitness_per_cycle <<"                 \r";
      harvey_display ();
      }

    return fitness_per_cycle;
#else
	return 0.0;
	
#endif 

}


//Return distance between two points

Real rdist(float x, float y, float x1, float y1)

{
 
  Real distance;

  distance = ((x-x1)*(x-x1)) + ((y-y1)*(y-y1));
  return(sqrt(float(distance)));
}



Real explor_battery (vector<robot *> & _vector_robots,environment & _env)

{
#ifndef DONT_USE_EO

  at_least_one_crash=false;
  
  khepera * khepera0 =(dynamic_cast<khepera *>(_vector_robots[0]));
    
  
  if (new_epoch) {
    (_env.all_lights[0])->x=((Real) rand())/RAND_MAX*_env.dx;
    (_env.all_lights[0])->y=((Real) rand())/RAND_MAX*_env.dy; 
   
    khepera0->battery=1.0;

  }


  double fitness_per_cycle = 0.0;

  if (khepera0->crash_obstacle) 

    {
	
      fitness_per_cycle-=10000.0;
      at_least_one_crash=true;
      return fitness_per_cycle;

    }

 

                  
  if (rdist( khepera0->centerx, khepera0->centery,(_env.all_lights[0])->x,(_env.all_lights[0])->y)<100.0)
      {
	khepera0->battery+=0.01;
	
	if (khepera0->battery>1.0)
	  khepera0->battery=1.0;
      
	
}
  
    else 
      {
	Real ave_mot =  (khepera0->left_motor_speed+khepera0->right_motor_speed)/2.0;
	
	fitness_per_cycle += ave_mot;
	
}
  
  
  if (khepera0->battery<0.0) 
    {

      
at_least_one_crash=true;
return fitness_per_cycle;

         }
  
  
  khepera0->battery -= 0.0035;
  
  if (draw_eo and new_epoch) new_epoch=false;

  return fitness_per_cycle;
#else
  return 0.0;
  
#endif 
  
}


#endif
